function eanbleDisplayAdv() {
    setLocVal("displayAdv", "true");
}

function disableDisplayAdv() {
    setLocVal("displayAdv", "");
}

function isDisplayAdvEnable() {
    return !!getLocVal("displayAdv");
}


/**
 * 缓存广告
 * @param {Object} waitTime 默认显示时间
 */

function cacheAdv(waitTime) {

    var url = global.SERVER_URL + "/yisuibao/pub/adv/appList.do?actionType=act";

    var param = [{
        'key' : 'ajax',
        'type' : '0',
        'value' : 'mobile'
    }, {
        'key' : 'filterTxt',
        'type' : '0',
        'value' : 'cIsValid'
    }, {
        'key' : 'filterType',
        'type' : '0',
        'value' : 'EQ'
    }, {
        'key' : 'filterBind',
        'type' : '0',
        'value' : 'cIsValid'
    }, {
        'key' : 'filterValue',
        'type' : '0',
        'value' : true
    }, {
        'key' : 'filterValueType',
        'type' : '0',
        'value' : 'BOOLEAN'
    }, {
        'key' : 'currentPage',
        'type' : '0',
        'value' : 1
    }, {
        'key' : 'pageSize',
        'type' : '0',
        'value' : 10
    }, {
        'key' : 'sortorder',
        'type' : '0',
        'value' : 'desc'
    }, {
        'key' : 'sortname',
        'type' : '0',
        'value' : 'nOrder'
    }];

    try {

        $.getJSON(url, function(data) {
            dealResult(data, function(data) {
                if (data && data.rows.length > 0) {// 如果存在广告
                    var adsData = {
                        "waitTime" : waitTime,
                        "data" : data.rows
                    }
                    setLocJson("advData", adsData);
                }
            }, function(data) {
                tip(data.resultMsg);
                return;
            });
        }, "json", getJSONError, "POST", param, false);
    } catch(e) {
        alert(e);
    }

}


/**
 *显示广告
 * @param {Object} once     是否只显示这一次 
 * @param {Object} resultPage 广告关闭之后的页面
 */
function displayAdv(once, resultPage) {

    var advData = getLocJson("advData");

    if (advData) {
        if (isDisplayAdvEnable()) {
            advData.resultPage = resultPage;
            setLocJson("advData", advData);
            openWin("../main/advs_content", '','', true);
        } else {
            openWin(resultPage,'','',true);
        }

    } else {
        openWin(resultPage,'','',true);
    }

    if (once) {
        disableDisplayAdv();
    }
}


