/**
 * 打开主窗口
 * 注意：生成的窗口名称为目录名和文件名以中划线连接，如path="../main/main.html",name="main-main"
 * @param string path 主窗口路径，如非根目录中，必须为相对根目录路径,如path="../main/main.html"
 * @param {Object} data 传参数，存放到缓存
 * @param integer inAniID 动画类型
 * @param boolean isReload 如该窗口已加载，是否刷新页面
 */
function openWin(path,data,inAniID,isReload){
	if(inAniID===0 || inAniID==='0'){
		inAniID=0;
	}else if(inAniID){
		inAniID=inAniID*1;
	}else{
		inAniID=2;
	}
	path=path.replace(/\s/g,"");
	var uri=path;
	var id=path;
	if(path.length>5 && path.substr(path.length-4).indexOf('.')>=0){
		id= path.substring(0,path.lastIndexOf('.'));
	}else{
		uri=path + ".html";
	}
	id=id.substring(0,1)=='.'?id.substr(id.lastIndexOf('\.\/')+2):id;
	id=replaceAll(id,'\\/','-');
	if(isReload){
		try {
			uexWindow.evaluateScript(id, 0, "reload();");
		}catch(e){};
	}
	logPv(id);
    uexWindow.open(id, 0, uri, inAniID, "", "", 0);
	if(data && typeof(data)=="object"){
		for(var key in data){
			setLocVal(id+"."+key,data[key]);
		}
	}
	if(data&&typeof(data)=="string"){
		var param=data.split(",");
		for (var i = 0; i < param.length; i++) {
			setLocVal(id + ".value"+i, param[i]);
		}
	}
}

function openTabContent(contentId, destId, url, x, y)
{
	var s=window.getComputedStyle($$(destId),null);
	uexWindow.openPopover(contentId,"0",url,"",int(x),int(y),int(s.width),int(s.height),int(s.fontSize),"0");
	uexWindow.bringPopoverToFront(contentId);
}

/**
 * 返回-即关闭主窗口
 */
function back(pageId,animiID){
	if(pageId){
		logClosePv(pageId);
	}
	if(animiID==undefined || animiID=="undefined" ||  animiID==null || animiID===""){
		animiID="-1";
	}
    uexWindow.close(animiID);
}

/**
 * localStorage保存数据
 * @param String key  保存数据的key值
 * @param String value  保存的数据
 */
function setLocVal(key,value){
	window.localStorage[key] = value;
}

/**
 * 根据key取localStorage的值
 * @param Stirng key 保存的key值
 */
function getLocVal(key){
	if(window.localStorage[key])
		return window.localStorage[key];
	else
		return "";
}
/**
 * localStorage保存JSON对象
 * @param String key  保存数据的key值
 * @param String value  保存的数据
 */
function setLocJson(key,value){
	if (value) {
		setLocVal(key, JSON.stringify(value));
	}else{
		setLocVal(key, "");
	}
}

/**
 * 根据key取localStorage的JSON对象
 * @param Stirng key 保存的key值
 */
function getLocJson(key){
	var str=getLocVal(key);
	if(str){
		return JSON.parse(str);
	}
	return "";
}

/**
 * 获取当前登录用户对象
 */
function getUser(){
	
	var user=getLocVal('fwk_user');
	if(user==""  && typeof(global)!=="undefined" && global && global.USER){
		user=global.USER;
	}else if(user){
		user=JSON.parse(user);
	}else{
		user=null;
	}
	
	return user;
	
}

/**
 * 获取当前登录用户设置对象
 */
function getUserSet(){
	var userSet=getLocVal('fwk_user_set');
	if(!userSet || userSet=="" ){
		return null;
	}
	return JSON.parse(userSet);
	
}

/**更新Userset属性*/
function updateUserSet(attr,value){
	if(attr===null||attr===undefined||attr===""){
		return;
	}
	var userSet=getUserSet();
	if(attr in userSet){
		userSet[attr]=value;
		setLocVal("fwk_user_set", JSON.stringify(userSet));
	}
}

/**更新当前随检用户信息*/
function updateSuijianUser(attr,value){
    if(attr===null||attr===undefined||attr===""){
        return;
    }
    var sjUser=getLocJson("suijian.user");
    if(attr in sjUser){
        sjUser[attr]=value;
        setLocJson("suijian.user", sjUser);
    }
}

/**
 * 获取当前登录用户姓名
 */
function getUserName(){
	var username=getLocVal('fwk_username');
	if(username=='' && typeof(global)!=="undefined" && global && global.USER && global.USER.cName){
		username=global.USER.cName;
	}
	return username;
}
/**
 * 获取当前登录用户ID
 */
function getUserId(){
	var userid=getLocVal('fwk_userid');
	if(userid=='' && typeof(global)!=="undefined" && global && global.USER && global.USER.cPkId){
		userid=global.USER.cPkId;
	}
	return userid;
}

/**
 * 获取当前登录用户的随宝号
 */
function getBizNo(){
	var bizno=getLocVal('fwk_user_bizno');
	if(bizno=='' && typeof(global)!=="undefined" && global && global.USER && global.USER.cBizNo){
		bizno=global.USER.cBizNo;
	}
	return bizno;
}
/**
 * 获取当前登录session id
 */
function getSessionId(){
	var sessionId=getLocVal('fwk_jsessionid');
	return sessionId;
}

/**
 * 获取当前登录session id
 */
function setSessionId(sessionId){
	if (sessionId) {
		setLocVal('fwk_jsessionid', sessionId);
	}else{
		clearLocVal('fwk_jsessionid');
	}
	return sessionId;
}
/**
 * 获取BizInfo
 */
function getBizInfo(){
	var bizInfo=getLocJson('fwk_biz_info');
	if(!bizInfo){
		return {};
	}
	return bizInfo;
}

/**
 * 获取BizInfo
 */
function setBizInfo(bizInfoStr){
	if (bizInfoStr) {
		setLocVal('fwk_biz_info', bizInfoStr);
	}else{
		clearLocVal('fwk_biz_info');
	}
}


/**
 * 打开全屏显示的浮动窗口
 * @param {Object} name 浮动窗口名称
 */
function openPop(name){
    uexWindow.openPopover(name, "0", name + ".html", "", 0, 0, getLocVal("phoneWidth"), getLocVal("phoneHeight"), "", "0");
}


/**
 * 打开浮动窗口选项
 * 注意：对应的主窗口mainWinName中必须引入hj_base.js
 * @param {String} mainWinName 主窗口名称
 * @param {Array} array 选项信息[{name:'',value:''}]
 * @param {String} callFun 回调函数名,该参数必须为字符串类型
 * @param {String} spanId 显示选项文字的块级元素ID
 * @param {String} inputId 显示选项值的输入元素ID
 * @param {Boolean} type 浮动窗口类型，默认为菜单选择，1：籍贯选择
 * @param {String} title 选择标题
 */
function openSelectPop(mainWinName,array,callFun,spanId,inputId,type,title,hasClearOption,options){
    var param={data:array,mainWinName:mainWinName,callFunName:callFun,spanId:spanId,inputId:inputId,type:type,
                        title:title,hasClearOption:hasClearOption,options:options};
    setLocVal("POP_MENU_SELECT_PARAM",JSON.stringify(param));
    uexWindow.evaluateScript(mainWinName, 0,  "openPopoverSelectPop()");
}

/**
 * 打开数字输入窗口
 * 注意：对应的主窗口mainWinName中必须引入hj_base.js
 * @param {String} mainWinName 主窗口名称
 * @param {Array} array 选项信息[{name:'',value:''}]
 * @param {String} callFun 回调函数名,该参数必须为字符串类型
 * @param {String} spanId 显示选项文字的块级元素ID
 * @param {String} inputId 显示选项值的输入元素ID
 * @param {Boolean} type 浮动窗口类型，默认为菜单选择，1：籍贯选择
 * @param {String} title 选择标题
 * @param {Object} condition 条件，例如{isInt:true, max:100, min:0, scale: 2} 表示只能输入整数，最大值为100，最小值为0, 保留两位小数
 */
function openNumPop(mainWinName,defVal,callFun,spanId,inputId,title,condition,options){
    var param={data:defVal,mainWinName:mainWinName,callFunName:callFun,spanId:spanId,inputId:inputId,type:2,
                        title:title,condition:condition,options:options};
    setLocVal("POP_MENU_SELECT_PARAM",JSON.stringify(param));
    uexWindow.evaluateScript(mainWinName, 0,  "openPopoverSelectPop()");
}


/**
 * 打开浮动窗口选项
 * 注意：该方法只能在主窗口中打开，否则不兼容IOS
 */
function openPopoverSelectPop(){
    var obj = JSON.parse(getLocVal("POP_MENU_SELECT_PARAM"));
	var dep=obj.mainWinName.split('-').length-1;
	var dir="";
	if(dep>0){
		for(var i=0;i<dep;i++){
			dir+='../';
		}
	}
	var path = dir+"common/menu_select";
	var id="common-menu_select";
	if (obj.type == 1) {
		path =dir+"common/birthplace_select_content";
		id="common-birthplace_select_content";
	} else if(obj.type == 2) {
	    path =dir+"common/num_input";
        id="common-num_input";
	}
    uexWindow.openPopover(id, "0", path + ".html", "", 0, 0, getLocVal("phoneWidth"), getLocVal("phoneHeight"), "", "0");
	 if (isAndroid()) {
			uexWindow.onKeyPressed = function(keyCode){
				if (keyCode == 0) {
					closeSelectPop(obj.type);
					uexWindow.setReportKey(0, 0);
				}
			};
			uexWindow.setReportKey(0, 1);//拦截android的返回键
	}
}


function openEditWin(mainWinName,title,content,spanId,inputId,cb,rule){
	var dep=mainWinName.split('-').length-1;
	var dir="";
	if(dep>0){
		for(var i=0;i<dep;i++){
			dir+='../';
		}
	}
	var path = dir+"common/text_edit";
	if((content==null||content===undefined||content==="undefined")&&inputId){
		content=$$(inputId).value;
	}
	var param={id:mainWinName,title:title,content:content,spanId:spanId,inputId:inputId,cb:cb,rule:rule};
	setLocVal("TEXT_EDIT_PARAM",JSON.stringify(param));
	openWin(path);
}

/***
 * 关闭选项浮动窗口
 */
function closeSelectPop(type){
	if (1==type) {
		uexWindow.closePopover("common-birthplace_select_content");
	}else if (2==type) {
		uexWindow.closePopover("common-num_input");
	}
	else {
		uexWindow.closePopover("common-menu_select");
	}
}

//添加格式化方法
Date.prototype.format = function(format){
    var o = {
        "M+": this.getMonth() + 1, //month 
        "d+": this.getDate(), //day 
        "h+": this.getHours(), //hour 
        "m+": this.getMinutes(), //minute 
        "s+": this.getSeconds() //second 
    }
    
    if (/(y+)/.test(format)) {
        format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    }
    
    for (var k in o) {
        if (new RegExp("(" + k + ")").test(format)) {
            format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
        }
    }
    return format;
}


/**
 * 对后台返回数据预处理
 * @param Object data 后台返回数据的JSON对象
 * @param function successCb 后台处理成功后执行的回调函数
 * @param function errorCb 后台处理失败后执行的回调函数
 */
function dealResult(data, successCb, errorCb){
	var result=null;
	if(data){
		if(data.userData && data.userData.resultType){
			result=data.userData;
		}else if(data.resultType){
			result=data;
		}
	}
	if (result && result.resultType=="SUCCESS") {
		if (successCb) {
			successCb(data,result);
		}else{
			closeTip();
		}
	}else if (result && result.resultType=="ERROR") {
		closeTip();
		if (result.custDataStr == "NO_GRANT") {
			setLogoutStatus();
			var j_username = getLocVal("fwk_j_username");
			var j_password = getLocVal("fwk_j_password");
			clearBizCache();
			if (j_username) {
				setLocVal("fwk_j_username", j_username);
			}
			if (j_password) {
				setLocVal("fwk_j_password", j_password);
			}
			setLocVal("fwk_isRemember", "1");
			setLocVal("fwk_isAutoLogin", "1");
			
//			autoLoginBase(function(){
//				tip("已自动登录",2000);
//			},function(){
//				openWin("../main/login");
//			});
			openWin("../main/login");
			return;
		}
		if (errorCb) {
			errorCb(data,result);
		}else {
			// 写入登录失败信息
			uexWindow.toast("0", "5", data.resultMsg, 2000);
		}
	}else{
		closeTip();
		if (errorCb) {
			errorCb(data);
		}else {
			// 写入登录失败信息
			uexWindow.toast("0", "5", data.resultMsg, 2000);
		}
	}
}

/**
 * 根据值获取类别名称(默认对象为{name:'',value:''})
 * @param {Object} value
 * @param String dataNameKey ojb中存储name的key
 * @param String dataValueKey ojb中存储value的key
 */
function getObjTypeName(obj,value,dataNameKey,dataValueKey){
	if(value==null||value==undefined||value===''){
		return null;
	}
	if (!dataNameKey) {
		dataNameKey = "name";
	}
	if (!dataValueKey) {
		dataValueKey = "value";
	}
	var result=null;
    if (obj) {
        for (var i = 0; i < obj.length; i++) {
            var temp = obj[i];
            if (temp[dataValueKey] == value) {
                result=temp[dataNameKey];
                break;
            }
        }
    }
	return result;
}

/**
 * 根据省份的编码获取城市对象数组
 * @param {Object} obj		数据源
 * @param {Object} value 省份编码
 */
function getCityArrayByProvince(obj,value){
	if(value==null||value==undefined||value==''){
		return null;
	}
	var result=[];
	if (obj) {
        for (var i = 0; i < obj.length; i++) {
            var temp = obj[i];
            if (temp.provinceValue == value) {
                result=temp.city;
                break;
            }
        }
    }
	return result;
}


/**
 * 根据城市的编码获取城市名称
 * @param {Object} obj		数据源
 * @param {Object} value 城市唯一编码，支持省编码
 */
function getCityNameByValue(obj,value){
	if(value==null||value==undefined||value==''){
		return null;
	}
	var homtownArr = value.split('-');
	var cities=[];
	var str="";
	if (obj && homtownArr) {
        for (var i = 0; i < obj.length; i++) {
            var temp = obj[i];
            if (temp.provinceValue == homtownArr[0]) {
				str=temp.provinceName;
				if(homtownArr.length==1 || !temp.city){
					return str;
				}
                cities=temp.city;
                break;
            }
        }
    }
	if (cities && homtownArr && homtownArr.length>1 && homtownArr[1]) {
		for (var i = 0; i < cities.length; i++) {
			if (cities[i].cityValue == homtownArr[1]) {
				str = str + "-" + cities[i].cityName;
				break;
			}
		}
	}
	return str;
}

/**
 * 获取籍贯显示名称
 * @param {Object} obj 数据源
 * @param {Object} proValue 省份编号
 * @param {Object} cityValue 城市编号
 */
function getNamesByProAndCityValue(obj,proValue,cityValue){
	var result="";
	if (obj) {
        for (var i = 0; i < obj.length; i++) {
            var temp = obj[i];
            if (temp.provinceValue == proValue) {
				result=temp.provinceName;
                var cityObj=temp.city;
				for(var k=0;k<cityObj.length;k++){
					if (cityObj[k].cityValue == cityValue) {
						result += cityObj[k].cityName;
						break;
					}
				}
                break;
            }
        }
    }
	return result;
}

function trimHtml(text){
	var patten =  new RegExp(String.fromCharCode(160),'g');
	var result = text.replace(/&nbsp;/g,'').replace(patten,'');
	result = result.replace(/\s/g,""); 
    return  result;
}
/**
 * 字符串全替换
 * str 原字符串
 * replacedStr 被替换字符串,转义字符要加"\\"
 * newStr 替换后的字符串
 * isCaseSensitive 被替换字符是否区分大小写,默认不区分
 */
function replaceAll(str,replacedStr,newStr,isCase){
	afterStr="/gi";
	if(isCase){
		afterStr="/g";
	}
	return str.replace(eval("/"+replacedStr+afterStr),newStr);
}
/**
 * 根据校验结果提示错误
 * @param {Object} errorList 错误对象列表
 * @param {Object} funGetName 获取错误对象名称的函数
 * @param {Object} objName 指定错误对象名称
 */
function showErrorMsg(errorList,funGetName,objName){
	if (jQuery && jQuery.attr ) {
		var msg = "";
		msg = (errorList[0].message);
		var trElem=objName;
		if (!trElem && funGetName) {
			trElem = funGetName(errorList[0].element);
		}
		if (!trElem) {
			trElem = jQuery(errorList[0].element).parent().parent().prev().text();
		}
		if (!trElem) {
			trElem="";
		}
		var validate = jQuery(errorList[0].element).attr('validate');
		if (validate.indexOf("messages") < 0) {
			if (trElem != null) {
				trElem = trimHtml(trElem);
				if (trElem.lastIndexOf("(") > 0) {
					trElem = trElem.substring(0, trElem.lastIndexOf("("));//过滤掉单位
				}
			}
			msg = trElem + ":" + msg;
		}
		jQuery(errorList[0].element).focus();
		if (msg != "") uexWindow.toast("0", "5", msg, 2000);
	}
}


/**
 * 将一般对象转换成$.getJSON支持的参数
 * @param {Object} arrObj 数组对象
 */
function obj2Param(arrObj){
	var param = new Array();
	if (arrObj) {
		var temp={};
		for (var key in arrObj) {
			if(!arrObj[key].value){
				continue;
			}
			var item=null;
			var tempKey=arrObj[key].name;
			if(tempKey && '_'==tempKey.substr(tempKey.length-2,1)){
				tempKey=tempKey.substr(0,tempKey.length-2);
			}
			item=temp[tempKey]?param[temp[tempKey]]:null;
			if(!item){
				item = {};
				item['key'] = tempKey;
				item['type'] = '0';
				item.value = arrObj[key].value;
				param.push(item);
				temp[tempKey]=param.length-1;
			}else{
				item.value=item.value+","+arrObj[key].value;
				param[temp[tempKey]]=item;
			}
		}
	}
	return param;
}
/**
 * 判断对象是否数组
 * @param {Object} o
 */
function isArray(o){
	return Object.prototype.toString.call(o) === '[object Array]';
}

/**
 * 显示选项值对应的名称
 * @param {Object} valueId 存储值的对象ID
 * @param {Object} textId  显示文本的对象ID
 * @param {Object} dataObj  值与文本映射的数据对象
 */
function showValueName(valueId,nameId,dataObj){
	if(!nameId){
		nameId=valueId+"_name"
		if(!$$(nameId) || $$(nameId).innerHTML=='undefined' || $$(nameId).innerHTML==null)return;
	}
	var value=$$(valueId).value;
	if(!dataObj){
		$$(nameId).innerHTML=value;
		return;
	}
	if (isArray(dataObj)) {
		for (var i in dataObj) {
			if (value == dataObj[i].value) {
				$$(nameId).innerHTML = dataObj[i].name;
				return;
			}
		}
	}else{
		$$(nameId).innerHTML =dataObj[valueId];
		return;
	}
}


/**
 * 设置页面弹动效果
 * @param {Object} bottomcb 底部弹动回调方法,为''则无效果
 * @param {Object} topcb 顶部弹动回调方法,为''则无效果
 */
function setPageBounce(bottomcb,topcb){
		if (!bottomcb && !topcb) {
			uexWindow.setBounce(0);
			return;
		}
        var s = ['0', '0'];
        uexWindow.onBounceStateChange = function (type,status){
                if (topcb && type == 0 && status == 2) {
					topcb();
					uexWindow.resetBounceView('0');
				}
                if (bottomcb && type == 1 && status == 2) {
					bottomcb();
					uexWindow.resetBounceView('1');
				}
        }
		uexWindow.setBounce(1);
        if(topcb){
                s[0] = '1';
				uexWindow.setBounceParams(0,
				'{"imagePath":"res://loading.png","textColor":"#00a0e9","levelText":"","pullToReloadText":"下拉可刷新页面 ","releaseToReloadText":"释放 刷新页面","loadingText":"刷新页面..."}');
                uexWindow.notifyBounceEvent(0,1);
        }
        uexWindow.showBounceView("0","#f0f0f0",s[0]);
        if(bottomcb){
                s[1] = '1';
				uexWindow.setBounceParams(1,
				'{"imagePath":"res://loading.png","textColor":"#00a0e9","levelText":"","pullToReloadText":"上拉可加载更多","releaseToReloadText":"释放 加载更多","loadingText":"加载更多..."}');
                uexWindow.notifyBounceEvent(1,1);
        }
        uexWindow.showBounceView("1","#f0f0f0",s[1]);
}

var isLoginOut=false;
/**
 * 退出系统
 */
function logout(){
	if (!isLoginOut) {
		isLoginOut=true;
		tip("再点一次退出！", 4000)
		setTimeout(function(){
			isLoginOut = false;
		}, 4000);
	}else {
		uexWidgetOne.exit(0);
	}
	
	//uexWidgetOne.exit();
	
//            var url =global.SERVER_URL+"/j_spring_security_logout?ajax=mobile";
//
//            $.getJSON(url, function(data){
//		 		dealResult(data,function(data){
//                  
//		 		},function(data,result){
//                  	uexWindow.toast("0", "5",  "退出系统", 2000);
//                });
//            },"",getJSONError, "GET", "", false);
}
/**
 * 刷新页面
 */
function reload(){
	window.location.reload();
}

/**
 * 刷新首页数据
 */
function refreshMain(){
	//uexWindow.evaluateScript("main-main", 0, "initData();");
	var cPkId = getLocJson("suijian.user").cUserId;
	uexWindow.evaluatePopoverScript("main-main", "content", "showSuijian('"+cPkId+"')");
}

/**
 * 刷新内容页面
 */
function reloadContent(mainWin,popName){
	if(!popName){
		popName="content";
	}
	uexWindow.evaluatePopoverScript(mainWin, popName, "reload()");
}
/**
 * 获取最后一个子元素节点
 * @param {Object} node
 */
function getLastChildElement(node){
	var x=node.lastChild;
	while (x.nodeType!=1){
	  x=x.previousSibling;
	}
	return x;
}

/**
 * 获取第一个子元素节点
 * @param {Object} node
 */
function getFirstChildElement(node){
	var x=node.firstChild;
	while (x.nodeType!=1){
	  x=x.nextSibling;
	}
	return x;
}

/**
 * 删除第一个子元素节点
 * @param {Object} nodeId  节点的ID
 */
function removeFirstChild(nodeId){
	var node = getFirstChildElement($$(nodeId));
	if(node){
		$$(nodeId).removeChild(node);
	}	
}

/**
 * 删除最后一个子元素节点
 * @param {Object} nodeId  节点的ID
 */
function removeLastChild(nodeId){
	$$(nodeId).removeChild(getLastChildElement($$(nodeId)));
}

/**
 * 
 * @param {Object} nodeId 父节点
 * @param {Object} node 需要插在第一位置的子节点
 */
function insertFirstChild(nodeId,node){
	var firstChild = $$(nodeId).firstChild;
	var secdonChild;
	 if(firstChild){
	 	if (firstChild.noteType != 1) {
			secdonChild = firstChild.nextSibling;
			if (!secdonChild) {
				$$(nodeId).appendChild(node);
			}
			else {
				$$(nodeId).insertBefore(node, secdonChild)
			}
		}else{
			$$(nodeId).insertBefore(node, firstChild);
		}
	}else{		
		$$(nodeId).appendChild(node);
	}
}

/**
 * 获取缓存的分页数据
 * @param {Object} cacheId 缓存数据的ID
 */
function getCachePageData(cacheId){
	var rowsData=getLocVal(cacheId);
	if (!rowsData) {
		rowsData = new Array();
	}else {
		rowsData = JSON.parse(rowsData);
	}
	return rowsData ;
}

/**
 * 缓存分页数据
 * @param {Object} cacheId  缓存数据的ID
 * @param {Object} rows 当前分页数据
 * @param {Object} currentPage 当前页号
 * @param {Object} pageSize 页大小
 */
function setCachePageData(cacheId,rows,currentPage,pageSize){
	var rowsData=getCachePageData(cacheId);
	var first=(currentPage-1)*pageSize;
	var last=first+rows.length-1;
	for(var i=0;i<rows.length;i++){
		rowsData[i+first]=rows[i];
	}
	setLocVal(cacheId,JSON.stringify(rowsData));
}

/**
 * 统一的消息提示
 * @param {Object} msg
 */
function tip(msg,time){
	if(!time){
		time=5000;
	}
	uexWindow.toast("0", "5", msg,time );
}

/**加载提示*/
function tipLoading(msg){
	if(!msg){
		msg="";
	}
	uexWindow.toast(1,5,msg,0);
}

/**关闭永久提示框*/
function closeTip(){
	uexWindow.closeToast();
}
/**
 * 调用系统浏览器打开网页
 * @param string url
 */
function openBrowser(url){
	if(isIos()){
       		uexWidget.loadApp(url,'','');
   	 }else{
			uexWidget.startApp("1", "android.intent.action.VIEW", '{"data":{"mimeType":"text/html","scheme":"'+url+'"}}');
	}
	logPv(url);
}

/**
 * 确认框
 * @param string msg 提示信息
 * @param function firstCallBack 点击第一个按钮时回调方法，当设置allCallBack时不起作用
 * @param Object callBackParam 传递给回调方法第一个参数
 * @param string titile 标题,可为空
 * @param Array buttonArray 按钮文本的数组
 * @param function allCallBack 点击所有按钮时的回调方法，此时firstCallBack时不起作用
 */
function confirm(msg,firstCallBack,callBackParam,titile,buttonArray,allCallBack){
	if(allCallBack){
		uexWindow.cbConfirm = function(opId, dataType, data){
			allCallBack(callBackParam,data);
		}
	}else{
		uexWindow.cbConfirm=function(opId,dataType,data){
			if (data == 0) {
				firstCallBack(callBackParam);
			}
	    }
	}
	if(!buttonArray){
		buttonArray=["是","否"];
	}
	if(!titile){
		titile="提示信息";
	}
	uexWindow.confirm(titile,msg,buttonArray);
}


/**
 * 模态提示确认框
 * @param string msg 提示信息
 * @param string titile 标题,可为空
 * @param string btnName 按钮名称,可为空
 */
function alertMsg(msg,title, btnName){
	if (msg) {
		if(!title){
			title="温馨提示";
		}
		if(!btnName){
			btnName="知道了";
		}
		uexWindow.alert(title, msg, btnName);
	}
}

/**
 * 地球半径
 */
var EARTH_RADIUS = 6378.137;

/**
 * 角度转换弧度
 * @param {Object} d	角度
 */
function rad(d){
    return d * Math.PI / 180.0;
}

/**
 * 通过两点经纬度，计算两点距离
 * @param {Object} lat1		点1纬度
 * @param {Object} lng1		点1经度
 * @param {Object} lat2		点2纬度
 * @param {Object} lng2		点2纬度
 */
function getDistance(lat1, lng1, lat2, lng2){
	if(!lat1 || !lng1 || !lat2 || !lng2){
		return "未知";
	}
    var radLat1 = rad(lat1);
    var radLat2 = rad(lat2);
    var a = radLat1 - radLat2;
    var b = rad(lng1) - rad(lng2);
    var s = 2 *
    Math.asin(Math.sqrt(Math.pow(Math.sin(a / 2), 2) +
    Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(b / 2), 2)));
    s = s * EARTH_RADIUS;
    s = Math.round(s * 100) / 100;
    return s;
    
}

/**
 * 遍历obj 根据对象中的value，获得对象的name
 * @param {Object} obj
 * @param {Object} value
 */
function valueToName(obj, value) {
	var ret = "";
	if(obj instanceof Array) {
		obj.forEach(function(e) {
			if(e.value == value) {
				ret = e.name;
			}
		});
		
	return ret;
		
	}
}



/**
 * 打开外部网页
 * @param {Object} name
 * @param {Object} title
 * @param {Object} url
 */
function openOuterWeb(name,title,url){
	if(!name || !title || !url){
		alert("打开外部页面参数错误！");
		return;
	}
	setLocVal("main-outer_web.title",title);
	setLocVal("main-outer_web.name",name);
	setLocVal("main-outer_web.url",url);
	openWin("../main/outer_web");
}


/**
 * sessionStorage保存数据
 * @param String key  保存数据的key值
 * @param String value  保存的数据
 */
function setSessVal(key,value){
	window.sessionStorage[key] = value;
}

/**
 * 根据key取sessionStorage的值
 * @param Stirng key 保存的key值
 */
function getSessVal(key){
	if(window.sessionStorage[key])
		return window.sessionStorage[key];
	else
		return "";
}


/**
 * 自动切换显示滑动块
 * @param {Object} slider 滑动块对象
 * @param {Object} interval 切换间隔时间，毫秒
 */
function autoSwitchSlide(slider,interval){
	var self = slider;
	if(!self)return;
	self.direct=true;
	if(!interval)interval=3000;
	window.setInterval(function(){ 
		if (self.direct && !self.hasNext()) {
			self.direct=false;
		}
		
		if (!self.direct && !self.hasPrev()) {
			self.direct=true;
		}
		if(self.direct){
			self.moveToPoint(self.currentPoint + 1);
		}else{
			self.moveToPoint(self.currentPoint - 1);
		}
		if(self.endFun)self.endFun();
	},interval); 
	
}

/**
 * 判断是否含有某样式class
 * @param {Object} obj
 * @param {Object} cls
 */
function hasClass(obj, cls) {
    return obj.className.match(new RegExp('(\\s|^)' + cls + '(\\s|$)'));
}
/**
 * 对象添加样式class
 * @param {Object} obj
 * @param {Object} cls
 */
function addClass(obj, cls) {
    if (!this.hasClass(obj, cls)) obj.className += " " + cls;
}

/**
 * 对象删除样式class
 * @param {Object} obj
 * @param {Object} cls
 */
function removeClass(obj, cls) {
    if (hasClass(obj, cls)) {
        var reg = new RegExp('(\\s|^)' + cls + '(\\s|$)');
        obj.className = obj.className.replace(reg, ' ');
    }
}

/**
 * 登录时更新状态
 */
function setLoginStatus(){
	setLocVal("fwk_IS_LOGIN","Y");//记录是否登录，注销登录则为N
	setLocVal("fwk_LOGIN_TIME_MILIS",new Date().getTime());//登录时间毫秒数，注销登录则清0
	
}
/**
 * 退出登录时更新状态
 */
function setNotLogout(){
	setLocVal("fwk_NOT_LOGOUT",true);
}
/**
 * 退出登录时更新状态
 */
function setLogoutStatus(){
	if (!getLocVal("fwk_NOT_LOGOUT")) {
		clearLocVal("fwk_IS_LOGIN");//记录是否登录，注销登录则为N
		clearLocVal("fwk_LOGIN_TIME_MILIS");//登录时间毫秒数，注销登录则清0
	}
	clearLocVal("fwk_NOT_LOGOUT");
}
/**
 * 退出登录时更新状态清空业务缓存数据
 */
function clearBizCache(){
	clearLocVal("fwk_user");
	clearLocVal("fwk_usertype");
	clearLocVal("fwk_username");
	clearLocVal("fwk_userid");
	clearLocVal("fwk_user_set");
	
	clearLocVal("main-login.needBack");
	clearLocVal("main-login.backPage");
}

/**
 * 判断是否已经登录
 */
function isLogin(){
	var isLogin=getLocVal("fwk_IS_LOGIN");//记录是否登录，注销登录则为N
	var loginTime=getLocVal("fwk_LOGIN_TIME_MILIS");//登录时间毫秒数，注销登录则清0
	if(!isLogin || !loginTime){
		return false;
	}
	if(isLogin=="Y" && (new Date().getTime()-loginTime*1)<global.SESSION_TIME_OUT*6000){
		return true;
	}
	return false;
}

/**
 * 判断是否已经登录
 * 如未登录则打开登录页面,登录后返回上一个页面
 * pageId传值，则返回时会刷新该页面
 */
function checkIsLogin(pageId){
	if(!isLogin()){
		openLogin(pageId);
		return false;
	}
	return true;
}

/**
 * 打开登录页面
 * 如果pageId不为空，则登录后返回上一个页面并刷新
 */
function openLogin(pageId){
	if (pageId) {
		setLocVal("main-login.needBack", "Y");
		setLocVal("main-login.backPage", pageId);
	}
	
	autoLoginBase(function(){
		//tip("已自动登录",2000);
		if ("main-main" != pageId) {
			reload();
		}
	},function(){
		openWin("../main/login");
	});
}

/**
 * 打开登录页面
 * 如果pageId不为空，则登录后返回上一个页面并刷新
 * @param pageId 登录后返回页面的ID，中划线分割目录
 * @param func 如果已经登录，则直接调用执行的函数
 */
function doWithLogin(pageId,func){
	if(!checkIsLogin(pageId)){
		return;
	}
	var userId = getUserId();
	if(userId) {
		func(userId,pageId);
	} else {
		openLogin(pageId);
	}
}


/**
 * 基础自动登录方法，在被后台权限拦截时自动登录
 * @param loginSucessCb 登录成功执行的函数
 * @param loginErrorCb 登录失败执行的函数
 */
function autoLoginBase(loginSucessCb,loginErrorCb){
	if(isLogin()){
		return;
	}
	var isAutoLogin=getLocVal("fwk_isAutoLogin");
    var j_username=getLocVal("fwk_j_username");
    var j_password=getLocVal("fwk_j_password");
	if(!isAutoLogin || isAutoLogin==="0" || !j_username || !j_password){
		if(loginErrorCb){loginErrorCb();}
		return ;
	}
	//tipLoading("自动登录…");
	var url = global.SERVER_URL + "/j_spring_security_check";
	var param = [{
		'key': 'ajax',
		'type': '0',
		'value': 'mobile'
	}, {
		'key': 'j_username',
		'type': '0',
		'value': j_username
	}, {
		'key': 'j_password',
		'type': '0',
		'value': j_password
	}];
	$.getJSON(url, function(data){
		dealResult(data, function(data){
			//closeTip();
			// 如果登录成功，则跳转到。
			setLocVal("fwk_usertype", data.usertype);//放入全局变量，可在其他页面获取
			setLocVal("fwk_username", data.user.cName);
			setLocVal("fwk_userid", data.userid);
			setLocVal("fwk_user", JSON.stringify(data.user));
			
			setLocVal("fwk_j_username", j_username);
			setLocVal("fwk_j_password", j_password);
			
			setLoginStatus();
			uexWindow.evaluatePopoverScript("main-main","content", "initData();");
			
			initUserSetBase();
			if(loginSucessCb){loginSucessCb();}
		}, function(data, result){
			//closeTip();
			if(loginErrorCb){loginErrorCb();}
		});
	}, "json", function(){/*closeTip();*/if(loginErrorCb){loginErrorCb();}}, "POST", param, false);
}

/**
 * 获取用户设置信息，配合自动登录方法
 */
function initUserSetBase(){
	var url =global.SERVER_URL+"/yisuibao/user/userset/getUserSet.do?actionType=act";
	var param =[{'key':'ajax','type':'0','value':'mobile'},
		{'key':'vo.cUserId','type':'0','value':getUserId()}];

    $.getJSON(url, function(data){
 		dealResult(data,function(data){
			setLocJson("fwk_user_set", data.custDataObj);
			setSuijianUser(data.custDataObj);
			setBizInfo(data.custDataStr);
			
			// 推送，绑定userId
			//GtPush.bindAlias(getUserId());
			try {
				 uexJPush.setAlias(JSON.stringify({alias:getUserId()}));
			} catch(e) {
				
			}
			
 		},function(data,result){
			//tip("未能获取用户信息！");
        });
    }, "json",function(){}, "POST", param, false);
}

/**
 * 获取当前定位坐标通用方法，可能存在5分钟延迟
 */
function getLocation() {
	var log=getLocVal("fwk_location_log");//经度
	var lat=getLocVal("fwk_location_lat");//纬度
	if(!log ||  !lat){
		updateLocation();
		return null;
	}
	
	var time=getLocVal("fwk_location_time");//时间戳
	if(time && (new Date().getTime()-time)>5*60*1000){
		updateLocation();
	}
	
	var locArr=new Array();
	locArr.push(log);
	locArr.push(lat);
	return locArr;
	
}
/**
 * 
 * @param {Object} isForce 是否强制更新定位
 */
function updateLocation(isForce){
	var isRunning=getLocVal("fwk_location_is_running");//是否正在定位
	var startTime=getLocVal("fwk_location_start_time");//开始定位时间戳
	if(isForce || !isRunning || isRunning=='N' || ( isRunning=='Y' && startTime && ((new Date().getTime()-startTime)>10*60*1000) )){
		setLocVal("fwk_location_is_running","Y");//是否正在定位
		setLocVal("fwk_location_start_time",new Date().getTime());//开始定位时间戳
		uexLocation.closeLocation();//开启定位前保证定位是关闭状态,定位处于开启状态时不能再调用开启定位功能，否则可能导致崩溃。
		uexLocation.onChange = locationOnChange;
		uexLocation.cbOpenLocation = locationCbOpenLocation;
		uexLocation.cbGetAddress = locationCbGetAddress;
		uexLocation.openLocation();
	}
}
/**
 * 最新定位成功获取坐标时回调的方法，提供给各个页面重写
 */
function cbLocationBiz(){
	
}


/**
 * 统一的定位成功后处理方法，此方法不推荐重写，可重写cbLocationBiz
 */
function locationOnChange(clat, clog){
	setLocVal("fwk_location_time",new Date().getTime());//时间戳
	setLocVal("fwk_location_log",clog);//经度
	setLocVal("fwk_location_lat",clat);//纬度
	uexLocation.closeLocation();
	setLocVal("fwk_location_is_running","N");//是否正在定位
	clearLocVal("fwk_location_start_time");//开始定位时间戳
	if(cbLocationBiz){
		var locArr=new Array();
		locArr.push(clog);
		locArr.push(clat);
		cbLocationBiz(locArr);
	}
}

function locationCbOpenLocation(opId, dataType, data){
//alert('cbOpenLocation:' + opId + "," + dataType + "," + data);
}
function locationCbGetAddress(opId, dataType, data){
//alert('cbGetAddreses:' + opId + "," + dataType + "," + data);
}



/**
 * 获取系统版本
 */
var _osVersion="";
var _isSimulator=null;
		
function getOsVersion(){
	if(_osVersion){
		return;
	}
	try {
		var platName = uexWidgetOne.platformName;
		if (platName) {
			platName = platName.toLowerCase();
			if (platName.indexOf("android") >= 0) {
				_osVersion = "android";
				_isSimulator="N";
				return;
			}else if(platName.indexOf("ios")>=0){
				_osVersion="ios";
				_isSimulator="N";
				return;
			}else if(platName.indexOf("simulator")>=0){//APPCAN模拟器
				_osVersion="android";
				_isSimulator="Y";
				return;
			}else{
				_osVersion=platName;
				_isSimulator="N";
				return;
			}
		}
		var platf=uexWidgetOne.getPlatform();
		if(platf==0){
			_osVersion="ios";
		}else if(platf==1){
			_osVersion="android";
		}
	}catch(e){
		_isSimulator = "N";
		return ;
	}
}

/**
 * 是否安卓系统
 */
function isAndroid(){
	getOsVersion();
	if(_osVersion && _osVersion.indexOf("android")>=0){
		return true;
	}
	return false;
}


/**
 * 是否苹果IOS系统
 */
function isIos(){
	getOsVersion();
	if(_osVersion && _osVersion.indexOf("ios")>=0){
		return true;
	}
	return false;
}

/**
 * 是否运行在模拟器
 */
function isSimulator(){
	if(!_osVersion){
		getOsVersion();
	}
	return ("Y"==_isSimulator)?true:false;
}

/**
 * 判断时候存在 class
 * @param {Object} obj
 * @param {Object} cls
 */
function hasClass(obj, cls) {
    return obj.className.match(new RegExp('(\\s|^)' + cls + '(\\s|$)'));
}

/**
 * 添加class
 * @param {Object} obj
 * @param {Object} cls
 */
function addClass(obj, cls) {
    if (!this.hasClass(obj, cls)) obj.className += " " + cls;
}

/**
 * 删除class
 * @param {Object} obj
 * @param {Object} cls
 */
function removeClass(obj, cls) {
    if (hasClass(obj, cls)) {
        var reg = new RegExp('(\\s|^)' + cls + '(\\s|$)');
        obj.className = obj.className.replace(reg, ' ');
    }
}

/**
 * 切换class
 * @param {Object} obj
 * @param {Object} cls
 */
function toggleClass(obj,cls){
	if(hasClass(obj,cls)){
		removeClass(obj, cls);
	}else{
		addClass(obj, cls);
	}
}

/**
 * 打电话
 * @param {Object} number
 */
function call(number){
	
	if (!number) 
		return;
	number = number.replace(/\-/g, "").replace(/\s/g, "");//去掉空格和-
	var nums = number.split(',');
	var numsWithTip = [];
	
	if(nums.length == 1) {		// 只有一个号码直接拨号
		if (isNaN(number)) {
			uexWindow.toast("0", "5", '电话号码不合法', 2000);
			return;
		}
		uexCall.call(number);
		return;
	}
	
	for (var i = 0, length = nums.length; i < length; i++) {
		numsWithTip[i] = '拨打号码 : ' + nums[i];
	}
	var cancelIndex = nums.length;
	uexWindow.cbActionSheet = function(opId, dataType, data){
		if (data == cancelIndex) 
			return;
		if (isNaN(nums[data])) {
			uexWindow.toast("0", "5", '电话号码不合法', 2000);
			return;
		}
		uexCall.call(nums[data]);
	}
	uexWindow.actionSheet("拨号", "取消", numsWithTip);
	
}


/**
 * 记录浏览量
 * @param {string} pageId 对应功能打开页面的Id,如主界面的pageId为"main-main"
 * @param {string} cOpNme 对应操作的名称
 * @param {string} cDesc 其它描述信息
 */
function logPv(pageId,cOpNme,cDesc){
	try {
		if(!pageId || !isLogin())return;
		var user=getUser();
		var url = global.SERVER_URL + '/yisuibao/analyze/pv/appAdd.do?actionType=act';
		var param = [{'key': 'ajax','type': '0','value': 'mobile'}, 
							{'key': 'vo.cOpCde','type': '0','value': pageId}, 
							{'key': 'vo.cOpNme','type': '0','value': cOpNme || ''}, 
							{'key': 'vo.cUserId','type': '0','value': (user?user["cPkId"]:'')}, 
							{'key': 'vo.cUserNme','type': '0','value': (user?user["cName"]:'')}, 
							{'key': 'vo.cDesc','type': '0','value': cDesc || ''}
							];
	    $.getJSON(url, function(data){
			var result=null;
			if(data && data["resultType"]){
				result=data;
			}
			if (result && result.resultType=="SUCCESS" && result.custDataStr) {
				setLocVal(pageId+".pagePvId",result.custDataStr);
			}else{
				clearLocVal(pageId+".pagePvId");
			}
	    }, "json", function(){clearLocVal(pageId+".pagePvId");}, "POST", param, false);
	}catch(e){};
}

/**
 * 记录关闭页面的时间
 * @param {string} pvId 打开页面时得到的pvId
 */
function logClosePv(pageId){
	try {
		if (!pageId  || !isLogin()) 
			return;
		var pvId = getLocVal(pageId + ".pagePvId") || '';
		if (!pvId) 
			return;
		var url = global.SERVER_URL + '/yisuibao/analyze/pv/updatePvEndTm.do?actionType=act&pvId=' + pvId;
		var param = [{
			'key': 'ajax',
			'type': '0',
			'value': 'mobile'
		}];
		$.getJSON(url, function(data){
		}, "json", function(){
		}, "POST", param, false);
	}catch(e){};
}


/**格式化2位数字*/
function format2b(s){
	if(s===null||s===""||s===undefined){
		return;
	}
	try{
		s=Number(s)+"";
	}catch(message){
		return s;
	};
    if (String.valueOf(s).length == 1) {
        if (s >= 0 && s < 10) {
            return "0" + s;
        }
        else {
            return s;
        }
    }
    return s;
}

/**
 * 打开日期选择框
 * @param {Object} id 日期赋值的元素ID 块级元素或输入框
 * @param {Object} ageId 年龄赋值的元素ID 块级元素或输入框
 * @param {Object} cb 回调函数(生日日期，年龄)
 */
function openDatePic(id,ageId,cb,flag){
			uexControl.cbOpenDatePicker = function(opCode, dataType, data){
                if (dataType == 1) {
                    var obj = eval('(' + data + ')');
                    var dateStr = obj.year + "-" + format2b(obj.month) + "-" + format2b(obj.day);
					var age=getAgeByBirth(dateStr);
					if(!flag&&age<=0){
						tip("请选择合法的出生日期");
						return;
					}
					if(id){
						$$(id).innerHTML=dateStr;
						$$(id).value=dateStr;
					}
					if(ageId){
						$$(ageId).innerHTML=age;
						$$(ageId).value=age;
					}
					if(cb){
						cb(dateStr,age);//生日日期、年龄
					}
                }
            };
		if(id===null||id===undefined||typeof(id)==="undefined"){
			uexControl.openDatePicker("1970","01","01");
			return;
		}
		var date=$$(id).value||$$(id).innerHTML;
		if(date&&/\d{4}-\d{2}-\d{2}/.test(date)){
				var dateStrArr=date.split("-");
				uexControl.openDatePicker(dateStrArr[0],dateStrArr[1],dateStrArr[2]);
		}else{
				uexControl.openDatePicker("1970","01","01");
		}
}

/** 判断推送是否打开 **/
function isPushEnable() {
	 var isPushNotice = getLocVal("fwk_isPushNotice-" + getUserId());
	 return isPushNotice !== "0";
}

/** 设置推送状态 **/
function setPushStatus(isEnable) {
	try {
		if(isEnable) {
			setLocVal("fwk_isPushNotice-" + getUserId(), "1");
			//GtPush.init(global.GE_TUI_APP_ID, global.GE_TUI_APP_KEY, global.GE_TUI_APP_SECRET);
			uexJPush.resumePush();
		} else {
			setLocVal("fwk_isPushNotice-" + getUserId(), "0");
			//GtPush.destroy();
			 uexJPush.stopPush();
			
		}
		
	} catch(e) {
		
	}
}

/**更新缓存中的用户信息*/
function updateFwkUser(attr,value){
	if(attr===null||attr===undefined||attr===""){
		return;
	}
	var user=getUser();
	if(attr in user){
		user[attr]=value;
		setLocVal("fwk_user", JSON.stringify(user));
	}
}

/** 添加列表为空提示到列表 **/
function appendListEmptyInfo(parentElemId, info) {
	// 导入字体
    var head = document.getElementsByTagName('head')[0];
    var link = document.createElement('link');
    link.href = "../css/iconfont/iconfont.css";
    link.rel = 'stylesheet';
    link.type = 'text/css';
    head.appendChild(link);
	
	// 添加内容
	var d = document.createElement('DIV');
	d.style.width="100%";
	d.style.marginTop="0.6em";
	d.innerHTML='<ul class="ub ub-ver tx-c c-wh uinn7"><li class="ub-f1 ub ub-ac ub-pc"><div class="ub-img7 img-nodata uwh-nodata uma-nodata" ></div></li><li class="ub-f1"><span class="ulev-1">'+info+'</span></li></ul>';
	//d.innerHTML='<ul class="ub ub-ver tx-c c-wh uinn7"><li class="ub-f1 iconfont"><span class="icon-information" style="font-size: 6em;color: #00a0e9;"></span></li><li class="ub-f1"><span class="ulev-1">'+info+'</span></li></ul>';
	document.getElementById(parentElemId).appendChild(d);
}

/** 个推 
var GtPush = (function() {
    var sysName;
    var aId;
    var aKey;
    var aSec;
    var Gt = function() {
	    this.status=null; // 0 启动，2 停止
        this.token = null;
        // 事件
         this.onErrorOccur = function(opId, dataType, data) {};
         this.onReceiveMessage = function(opId, dataType, data) {};
         this.onSetTags = function(opId, dataType, data) {};
         this.onBindAlias = function(opId, dataType, data) {};
         this.onUnbindAlias = function(opId, dataType, data) {};
         this.onRegisterDeviceToken = function(opId, dataType, data) {};
         this.onInitializePusher = function(opId, dataType, data) {};
        
        this.init = function(appId, appKey, appSecret) {
           try {
	            aId = appId;
	            aKey = appKey;
	            aSec = appSecret;
	            
	             // 个推事件
	            uexGetui.onInitializePusher = this.onDefaultInitializePusher;
	            uexGetui.onErrorOccur = this.onErrorOccur;
	            uexGetui.onReceiveMessage = this.onReceiveMessage;
	            uexGetui.onSetTags = this.onSetTags;
	            uexGetui.onBindAlias = this.onBindAlias;
	            uexGetui.onUnbindAlias = this.onUnbindAlias;
	            uexGetui.onRegisterDeviceToken = this.onRegisterDeviceToken;
	            
	            uexDevice.cbGetInfo = this.geTuiInitialize;     // 获得系统信息后，回调个推初始化方法
	            uexDevice.getInfo("1");
		   } catch(e) {
		   	uexWindow.toast("0", "5", '推送插件初始化失败，请检查打包的时候时候导入插件,' + e, 2000); 
		   }
           
        };
        
        // 个推初始化
        this.geTuiInitialize = function(opId, dataType, data) {
             if (data != null) {
                sysName = data.toString().toLowerCase();
                
                var params = {
                    appId : aId,
                    appKey : aKey,
                    appSecret : aSec
                };
                var data = JSON.stringify(params);
                uexGetui.initialize(data); 
                
             }
         };
         
        // 默认初始回调
        this.onDefaultInitializePusher = function(opId, dataType, data) {
            var object = JSON.parse(data);
            gt.status = object.result;

            if (gt.status == 0) {
                if (sysName.indexOf("android") == -1) {// 非安卓设备
                    uexGetui.registerDeviceToken();
                }
            } else {
                 uexWindow.toast("0", "5", object.error, 2000); 
            }
            gt.onInitializePusher(opId, dataType, data);
        }; 

         
         // 接口方法
        this.registerDeviceToken = function() {
			if(typeof(uexGetui) == "undefined") {
				return;
			}
			
			//if(gt.status == 0) {
           		uexGetui.registerDeviceToken();
			//}
        }
       
        this.getClientId = function() {
			if(typeof(uexGetui) == "undefined") {
				return;
			}
            return uexGetui.clientId();
        }
        // Set tags
        this.setTags = function(tagName) {
			if(typeof(uexGetui) == "undefined") {
				return;
			}
			//if(gt.status == 0) {
           	 	uexGetui.setTags(tagName);
			//}
        }
        // Bind alias
        this.bindAlias = function(alias) {
			if(typeof(uexGetui) == "undefined") {
				return;
			}
			//if(gt.status == 0) {
            	uexGetui.bindAlias(alias);
			//}
        }
        // Unbind alias
        this.unbindAlias = function(alias) {
			if(typeof(uexGetui) == "undefined") {
				return;
			}
			//if (gt.status == 0) {
				uexGetui.unbindAlias(alias);
			//}
        }
        // destroy
        this.destroy = function(alias) {
			if(typeof(uexGetui) == "undefined") {
				return;
			}
            //if(gt.status == 0) {
                uexGetui.destroy();
            //}
        }
        

    }
    var gt = new Gt();
    return gt;
       
})();
**/

function getAgeByBirth(birthStr){
	if(!birthStr)return "";
	var birth=new Date(birthStr).getTime();;
	var now=new Date().getTime();
	var sub=Math.floor((now-birth)/(60*1000*60*24*365));
	return sub;
}


/**
 * 扫二维码
 * @param {Object} cbFunc(opCode, dataType, data) 回调函数，
 * 		opCode:操作ID,open失败时为1,正常时为0,失败时一般是用户禁止了APP摄像头权限
 * 		dataType:不用管
 * 		data：返回数据
 * @param {Object} tipLabel 扫描区下部提示语,可选
 * @param {Object} title 扫描界面顶部标题 (仅iOS支持),可选
 * @param {Object} lineImg 扫描时移动的光线,可选
 * @param {Object} pickBgImg 扫描区域边框图片, 可选
 */
function scanQrCode(cbFunc,tipLabel,title,lineImg,pickBgImg){
	if(!cbFunc){
		tip("未设置扫码的后续处理!");
		return;
	}
	if(typeof(uexScanner) =='undefined'){
		tip("未打包扫码插件!");
		return;
	}
	/*
	var jsonData = '{"lineImg":"res://line.png","pickBgImg":"res://pick_bg.png","tipLabel":"对准二维码/条形码,即可自动扫描","title":"扫一下"}';
	if (uexScanner.setJsonData) {
		uexScanner.setJsonData(jsonData);
	}
	*/
	uexScanner.cbOpen = cbFunc;
	uexScanner.open();
}

/**
 * 扫描业务二维码
 * @param {Object} cbFunc(bizType,bizValue) 回调函数，
 * 		bizType:业务类型编码
 * 		bizValue:业务编码值
 * @param {Object} tipLabel 扫描区下部提示语,可选
 * @param {Object} title 扫描界面顶部标题 (仅iOS支持),可选
 * @param {Object} lineImg 扫描时移动的光线,可选
 * @param {Object} pickBgImg 扫描区域边框图片, 可选
 */
function scanBizQrCode(cbFunc,tipLabel,title,lineImg,pickBgImg){
	if(!cbFunc){
		tip("未设置扫码的后续处理!");
		return;
	}
	uexScanner.cbOpen = function (opCode, dataType, data){
		if(opCode=="1"){
			tip("请在手机设置里开启医随宝调用摄像头的权限");
			return;
		}
		if(!data){
			tip("无法识别此二维码");
			return;
		}
		var data=JSON.parse(data);
		if(data.type!='QR_CODE' && data.type!='QRCode' && data.type!='QR-Code' && data.type!='QR Code'){
			tip("无法识别此二维码");
			return;
		}
		var rqData=data.code;
		
		//兼容其它形式（如URL）的医随宝二维码
		var idx=rqData.indexOf("m=ysb_");
		if(idx>0 || rqData.indexOf("ysb_")>-1){
			if(idx>0){
				rqData=rqData.substring(idx+2);
			}
			var qrInfo=rqData.split("_");
			var bizType=qrInfo[1];
			var bizValue=qrInfo[2];
			//设备imie转换成设备序号
			if(bizType.indexOf("d")==0 && bizType.indexOf("dt")<0){
				if(bizType.length!=6){
					tip("无法识别此二维码");
					return;
				}
				bizValue=bizType.substring(1)+bizValue;
			}
			cbFunc(bizType,bizValue,rqData);
			return;
		}
		
		if(rqData.indexOf("http") == 0){
			openBrowser(rqData);
			return;
		}
		
		tip("无法识别此二维码");
		return;
	};
	uexScanner.open();
}

function hasEmoji(value){
	if(!value){
		return false;
	}
	return /[\ud800-\udbff][\udc00-\udfff]/g.test(value); 
}



function updateAlarm(userId) {
    
    try {
        var userId = userId || getUserId();
        if(!userId) return;
        
        var param = {
            "cUserId" : userId,
            "updateUrl" : global.ALARM_UPDATE_GATEWAY,
			"delayTime": global.DELAY_TIME,
            "pollingTime":global.POLLING_TIME
        }
        uexAlarm.updateAlarm(JSON.stringify(param));
        
    } catch(e) {
        console.log(e);
    }
   
}

function emptyAlarm() {
    try {
        var param = {
            "cUserId" : "",
            "updateUrl" : ""
        }
        uexAlarm.updateAlarm(JSON.stringify(param));
		uexAlarm.clearAlarm();
		uexAlarm.close();
    } catch(e) {
        console.log(e);
    }
   
}
/**
 * 打开日期选择框
 * @param {Object} id 日期赋值的元素ID 块级元素或输入框
 * @param {Object} cb 回调函数
 */
function openDateSelect(id,cb){
			uexControl.cbOpenDatePicker = function(opCode, dataType, data){
                if (dataType == 1) {
                    var obj = eval('(' + data + ')');
                    var dateStr = obj.year + "-" + format2b(obj.month) + "-" + format2b(obj.day);
					if(id){
						$$(id).innerHTML=dateStr;
						$$(id).value=dateStr;
					}
					if(cb){
						cb(dateStr);
					}
                }
            };
		var now=new Date();
		if(id===null||id===undefined||typeof(id)==="undefined"){
			uexControl.openDatePicker(now.getFullYear(),now.getMonth()+1,now.getDate());
			return;
		}
		var date=$$(id).value||$$(id).innerHTML;
		if(date&&/\d{4}-\d{2}-\d{2}/.test(date)){
				var dateStrArr=date.split("-");
				uexControl.openDatePicker(int(dateStrArr[0]),int(dateStrArr[1]),int(dateStrArr[2]));
		}else{
				uexControl.openDatePicker(now.getFullYear(),now.getMonth()+1,now.getDate());
		}
}

function openTimePic(id,cb){
			uexControl.cbOpenTimePicker = function(opCode, dataType, data){
                if (dataType == 1) {
                    var obj = eval('(' + data + ')');
                    var timeStr = format2b(obj.hour) + ":" + format2b(obj.minute);
					if(id){
						$$(id).innerHTML=timeStr;
						$$(id).value=timeStr;
					}
					if(cb){
						cb(obj,timeStr);
					}
                }
            };
		var now=new Date();
		if(!isDefine(id)){
			uexControl.openTimePicker(now.getHours(),now.getMinutes());
			return;
		}
		var date=$$(id).value||$$(id).innerHTML;
		if(date&&/\d{1,2}:\d{2}/.test(date)){
				var timeStrArr=date.split(":");
				uexControl.openTimePicker(int(timeStrArr[0]),int(timeStrArr[1]));
		}else{
				uexControl.openTimePicker(now.getHours(),now.getMinutes());
		}
}

/**
 * 设置安卓手机的返回键调用指定JS方法
 * 此方法必须在主窗口调用
 * @param function cbFunc 按返回键需调用的JS方法，为空则调用back()
 */
function setBackKey(cbFunc){
	if (isAndroid()) {
        uexWindow.onKeyPressed = function(keyCode){
            if (keyCode == 0) {
                if(cbFunc){
					cbFunc();
				}else{
					back();
				}
            }
        };
        uexWindow.setReportKey(0, 1);//拦截android的返回键
    }
}

/**检查用户信息是否完善*/
function checkUserInfo() {
	try {
		var user = getUser();
		if (user["cSex"] == null || user["cSex"] == "" || !getUserSet()["tBirthTm"]) {
			//跳转到引导信息页面
			openWin("../main/tip2");
			return false;
		}
		if (!getUserSet()["nHeightValue"] || !getUserSet()["nWeightValue"]) {
			openWin("../main/tip3");
			return false;
		}
		if (!getUserSet()["cIsDise"]) {
			openWin("../main/tip4");
			return false;
		}
	}catch(e){}
	return true;
}

