
/** 从新版appcan中抽取的file模块  **/
var hjFile = (function(){
    
    //var uexFileMgr = window.uexFileMgr;
    /*
    获取操作 id

    */
    var class2type = {};
    var toString = class2type.toString;
    
    "Boolean Number String Function Array Date RegExp Object Error".split(" ").forEach(function(name, i) {
        class2type[ "[object " + name + "]" ] = name.toLowerCase()
    })
    
    
    var getOptionId = function(){
        var maxId = 65536;
        var uid = 0;
        return function(){
            uid = (uid+1)%maxId;
            return uid;
        };
    }();;
    
     function type(obj) {
        return obj == null ? String(obj) :
          class2type[toString.call(obj)] || "object"
      }
     function isWindow(obj)     { return obj != null && obj == obj.window }
    function isFunction(value) { return type(value) == "function" }
    function isObject(obj)     { return type(obj) == "object" }
    function isPlainObject(obj) {
        return isObject(obj) && !isWindow(obj) && Object.getPrototypeOf(obj) == Object.prototype
    }
    function isString(obj){ return typeof obj == 'string' }
    
    

    /*
    文件是否存在
    @param String filePath 文件路径
    @param Function callback 又返回结果时的回调

    */
    
    var existQueue = {};//出来是否存在的队列
    var writeGlobalQueue = [];//写队列
    var readGlobalQueue = [];//读队列
    var readOpenGlobalQueue = [];//读队列
    var statQueue = [];//stat方法使用队列
    var statQueueUsed = [];
    
    function processExistCall(optId,dataType,data){
        //var callback = existQueue['exist_call_'+optId];
		try {
			var callback = existQueue['exist_call_'+optId].cb;
	        var filePath = existQueue['exist_call_'+optId].fp;
	        if(isFunction(callback)){
	            if(dataType == 2){
	                callback(null,data,dataType,optId,filePath);
	            }else{
	                callback(new Error('exist file error'),data,dataType,optId,filePath);
	            }
	        }
	        //当调用一次后释放掉
	        delete existQueue['exist_call_'+optId];
		} catch(e) {
			
		}
        
    }
    
    function exists(filePath,callback,optId){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            callback = argObj.callback;
            optId = argObj.optId;
        }
        optId = optId || getOptionId();
        if(isFunction(callback)){
            existQueue['exist_call_' + optId] = {cb:callback,fp:filePath};
            uexFileMgr.cbIsFileExistByPath = function(optId,dataType,data){
                processExistCall.apply(null,arguments);
            };
        }
        uexFileMgr.isFileExistByPath(optId,filePath);
        close(optId);
    }
    
    /*
    返回文件的相关信息
    @param String filePath
    @param Function callback
    */
    
    function stat(filePath,callback){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            callback = argObj.callback;
        }
        
        if(statQueue.length > 0){
            statQueue.push({fp:filePath,cb:callback});
        }else{
            statQueue.push({fp:filePath,cb:callback});
            execStatQueue();
        }
    }
    
    //执行存在队列
    function execStatQueue(){
        if(statQueue.length < 1){
            return;
        }
        var execStat = statQueue[0];
        var filePath = execStat.fp;
        var callback = execStat.cb;
        
        if(isFunction(callback)){
            uexFileMgr.cbGetFileTypeByPath = function(optId,dataType,data){
                if(dataType != 2){                 
                    callback(new Error('get file type error'),null,dataType,optId,filePath);
                    //processStatGlobalQueue(new Error('get file type error'),null,dataType,optId);
                    return;
                }
                var res = {};
                if(data == 0){
                    res.isFile = true;
                }
                if(data == 1){
                    res.isDirectory = true;
                }
                callback(null,res,dataType,optId,filePath);
                //processStatGlobalQueue(null,res,dataType,optId);
                statQueue.shift();
                if(statQueue.length){
                    execStatQueue();
                }else{
                    //alert('exec over');
                }
            };
        }else{
            statQueue.shift();
            if(statQueue.length){
                execStatQueue();
            }
        }
        uexFileMgr.getFileTypeByPath(filePath);
    }

    /*
                        处理全局回调read消息
        @param string msg 传递过来的消息
    
    */
    function processReadGlobalQueue(err,data,dataType,optId){
		try {
			if (readGlobalQueue.length > 0) {
				readGlobalQueue.forEach(function(v, i){
					if (v && v.cb && isFunction(v.cb)) {
						if (v.readOptId == optId) {
							v.cb(err, data, dataType, optId);
						}
					}
				});
			}
		} catch(e) {
			
		}
        return
    }
    
   /*
                        处理全局回调readOpen消息
        @param string msg 传递过来的消息
    
    */
    function processReadOpenGlobalQueue(err,data,dataType,optId){
        try {
	        if(readOpenGlobalQueue.length > 0){
	            readOpenGlobalQueue.forEach(function(v,i){
	                if(v && v.cb && isFunction(v.cb)){
	                    if(v.optId == optId){
	                        v.cb(err,data,dataType,optId);
	                    }
	                }
	            });
	        }
			
		} catch(e) {
			
		}
        return
    }

    /*
    读取文件内容
    @param String filePath 文件路径
    @param String callback 结果回调
    */
    function read(filePath,length,callback){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            length = argObj.length;
            callback = argObj.callback;
        }
        if(!filePath){
            return callback(new Error('file name is empty'));
        }
        if(isFunction(length)){
            callback = length;
            length = -1;
        }
        callback = isFunction(callback)?callback:function(){};
        length = length || -1;
        var optId = getOptionId();
        readGlobalQueue.push({fPath:filePath,cb:callback,readOptId:optId});
        exists(filePath,function(err,res,dataType,optId,filePath){
            if(err){
                readGlobalQueue.forEach(function(v,i){
                    if(v && v.fPath == filePath){
                        return v.cb(err);
                    }
                })
                //return callback(err);
            }
            
            if(!res){
                readGlobalQueue.forEach(function(v,i){
                    if(v && v.fPath == filePath){
                        return v.cb(new Error('文件不存在'));
                    }
                })
                //return callback(new Error('文件不存在'));
            }
            stat(filePath,function(err,fileInfo,dataType,optId,filePath){
                if(err){
                    readGlobalQueue.forEach(function(v,i){
                        if(v && v.fPath == filePath){
                            return v.cb(err);
                        }
                    })
                    //return callback(err);
                }
                if(!fileInfo.isFile){
                    readGlobalQueue.forEach(function(v,i){
                        if(v && v.fPath == filePath){
                            return v.cb(new Error('该路径不是文件'));
                        }
                    })
                    //return callback(new Error('该路径不是文件'));
                }
                uexFileMgr.cbReadFile = function(optId,dataType,data){
                    if(dataType != 0){
                        //callback(new Error('read file error'),data,dataType,optId);
                        processReadGlobalQueue(new Error('read file error'),data,dataType,optId);
                    }
                    //callback(null,data,dataType,optId);
                    processReadGlobalQueue(null,data,dataType,optId);
                };
                readOpen(filePath,1,function(err,data,dataType,optId){
                    uexFileMgr.readFile(optId,length);
                    close(optId);
                });
            });
        },optId);
    }
    
    
    /*
    读加密的文件内容
    
    
    */
    
    function readSecure(filePath,length,key,callback){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            length = argObj.length;
            key = argObj.key;
            callback = argObj.callback;
        }
        if(!filePath){
            return callback(new Error('file name is empty'));
        }
        callback = isFunction(callback)?callback:function(){};
        length = length || -1;
        exists(filePath,function(err,res){
            if(err){
                return callback(err);
            }
            if(!res){
                return callback(new Error('文件不存在'));
            }
            stat(filePath,function(err,fileInfo){
                if(err){
                    return callback(err);
                }
                if(!fileInfo.isFile){
                    return callback(new Error('该路径不是文件'));
                }
                uexFileMgr.cbReadFile = function(optId,dataType,data){
                    if(dataType != 0){
                        callback(new Error('read file error'),data,dataType,optId);
                    }
                    callback(null,data,dataType,optId);
                };
                openSecure(filePath,1,key,function(err,data,dataType,optId){
                    uexFileMgr.readFile(optId,length);
                    close(optId);
                });
            });
        });
    }

    /*
    获取文件的json形式
    @param String filePath 文件的路径
    @param Function callback 文件读取完成之后的回调

    */
    function readJSON(filePath,callback){
        
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            callback = argObj.callback;
        }
        
        read({
            filePath:filePath,
            callback:function(err,data){
                var res = null;
                if(err){
                    return callback(err);
                }
                try{
                    if(!data){
                        res = {};
                    }else{
                        res = JSON.parse(data);
                    }
                    callback(null,res);
                }catch(e){
                    return callback(e);
                }
            }
        });
    }

     /*
        处理全局回调openwrite消息
        @param string msg 传递过来的消息
    
    */
    function processWriteGlobalQueue(err,data,dataType,optId){
		try {
	        if(writeGlobalQueue.length > 0){
	            writeGlobalQueue.forEach(function(v,i){
	                if(v && v.cb && isFunction(v.cb)){
	                    if(v.optId == optId){
	                        v.cb(err,data,dataType,optId,v.ct);
	                    }
	                }
	            });
	        }
		} catch(e) {
			
		}
        return
    }

    /*
    写文件
    @param String filePath 文件路径
    @param String mode  写入方式
    @param String content 写入内容

    */
    function write(filePath,content,callback,mode){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            content = argObj.content;
            mode = argObj.mode;
            callback = argObj.callback;
        }
        mode = mode || 0;
        if(isFunction(content)){
            callback = content;
            content = '';
        }
        writeOpen(filePath,2,function(err,data,dataType,optId,contents){
            if(err){
                return callback(err);
            }
            uexFileMgr.writeFile(optId,mode,contents);
            close(optId);
            callback(null); 
        },content);
    }
    
    /*
    以安全的方式写入文件内容
    @param String filePath 文件路径
    @param String mode  写入方式
    @param String content 写入内容
    @param String key 要写入文件的密码

    */
    function writeSecure(filePath,content,callback,mode,key){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            content = argObj.content;
            mode = argObj.mode;
            key = argObj.key;
            callback = argObj.callback;
        }
        mode = mode || 0;
        if(isFunction(content)){
            key = mode;
            mode = callback;
            callback = content;
            content = '';
        }
        openSecure(filePath,2,key,function(err,data,dataType,optId){
            if(err){
                return callback(err);
            }
            uexFileMgr.writeFile(optId,mode,content);
            close(optId);
            callback(null);
        });
    }

    /*
    附近文件到文件的末尾
    @param String filePath 文件路径
    @param String content 内容
    @param Function 回调

    */

    function append(filePath,content,callback){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            content = argObj.content;
            callback = argObj.callback;
        }
        return write(filePath,content,callback,1);
    }
    
    /*
    附近文件到文件的末尾
    @param String filePath 文件路径
    @param String content 内容
    @param String key 加密key
    @param Function 回调

    */

    function appendSecure(filePath,content,key,callback){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            content = argObj.content;
            key = argObj.key;
            callback = argObj.callback;
        }
        return writeSecure(filePath,content,callback,1,key);
    }


    /*
    打开流
    @param String filePath 文件路径
    @param String mode 打开方式

    */
    function open(filePath,mode,callback){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            mode = argObj.mode;
            callback = argObj.callback;
        }
        if(isFunction(mode)){
            callback = mode;
            mode = 3;
        }
        mode = mode || 3;
        if(!isString(filePath)){
            return callback(new Error('文件路径不正确'));
        }
        //var optId = getOptionId();
        if(isFunction(callback)){
            uexFileMgr.cbOpenFile = function(optId,dataType,data){
                if(dataType != 2){
                    callback(new Error('open file error'),data,dataType,optId);
                    return;
                }
                callback(null,data,dataType,optId);
            };
        }
        uexFileMgr.openFile(getOptionId(),filePath,mode);
        //close(optId);
    }
    
    /*
           write调用打开流
    @param String filePath 文件路径
    @param String mode 打开方式

    */
    function writeOpen(filePath,mode,callback,content){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            mode = argObj.mode;
            callback = argObj.callback;
        }
        if(isFunction(mode)){
            callback = mode;
            mode = 3;
        }
        mode = mode || 3;
        if(!isString(filePath)){
            return callback(new Error('文件路径不正确'));
        }
        var optId = getOptionId();
        writeGlobalQueue.push({optId:optId,cb:callback,ct:content});
        if(isFunction(callback)){
            uexFileMgr.cbOpenFile = function(optId,dataType,data){
                if(dataType != 2){
                    //callback(new Error('open file error'),data,dataType,optId,content);
                    processWriteGlobalQueue(new Error('open file error'),data,dataType,optId);
                    return;
                }
                //callback(null,data,dataType,optId,content);
                processWriteGlobalQueue(null,data,dataType,optId);
            };
        }
        uexFileMgr.openFile(optId,filePath,mode);
        
        //close(optId);
    }
    
    /*
           write调用打开流
    @param String filePath 文件路径
    @param String mode 打开方式

    */
    function readOpen(filePath,mode,callback){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            mode = argObj.mode;
            callback = argObj.callback;
        }
        if(isFunction(mode)){
            callback = mode;
            mode = 3;
        }
        mode = mode || 3;
        if(!isString(filePath)){
            return callback(new Error('文件路径不正确'));
        }
        var optId = null;
        readGlobalQueue.forEach(function(v,i){
            if(v.fPath && v.fPath == filePath){
                optId = v.readOptId;
            }
        })
        if(!optId){
            optId = getOptionId();
        }
        if(isFunction(callback)){
            
            readOpenGlobalQueue.push({optId:optId,cb:callback});
            uexFileMgr.cbOpenFile = function(optId,dataType,data){
                
                if(dataType != 2){
                    //callback(new Error('open file error'),data,dataType,optId,content);
                    processReadOpenGlobalQueue(new Error('open file error'),data,dataType,optId);
                    return;
                }
                //callback(null,data,dataType,optId,content);
                processReadOpenGlobalQueue(null,data,dataType,optId);
            };
        }
        uexFileMgr.openFile(optId,filePath,mode);
        
        //close(optId);
    }
    
    /*
    打开加密文件
    @param String filePath 文件路径
    @param String mode 模式
    @param String key 加密字符串
    @param Function callback 打开加密文件成功后的回调
    
    */
    
    function openSecure(filePath,mode,key,callback){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            mode = argObj.mode;
            key = argObj.key;
            callback = argObj.callback;
        }
        key = key? key : '';
        mode = mode || 3;
        if(!isFunction(callback)){
            callback = null;
        }
        if(!isString(filePath)){
            return callback(new Error('文件路径不正确'));
        }
        //var optId = getOptionId();
        if(isFunction(callback)){
            uexFileMgr.cbOpenSecure = function(optId,dataType,data){
                if(dataType != 2){
                    callback(new Error('open secure file error'),data,dataType,optId);
                    return;
                }
                callback(null,data,dataType,optId);
            };
        }
        uexFileMgr.openSecure(getOptionId(),filePath,mode,key);
        //close(optId);
    }
    
    

    /*
    删除文件
    @param String filePath 文件路径
    @param Function callback 删除结果回调函数

    */

    function deleteFile(filePath,callback){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            callback = argObj.callback;
        }
        var optId = getOptionId();
        if(isFunction(callback)){
            uexFileMgr.cbDeleteFileByPath = function(optId,dataType,data){
                if(dataType != 2){
                    return callback(new Error('delete file error'));
                }
                callback(null,data,dataType,optId);
            };
        }
        uexFileMgr.deleteFileByPath(filePath);
        close(optId);
    }

    /*
    关闭文件流
    @param String optId 操作id

    */
    function close(optId){
        if(arguments.length === 1 && isPlainObject(optId)){
            optId = optId.optId;
        }
        if(!optId){
            return;
        }
        uexFileMgr.closeFile(optId);
    }
    
    

    /*
    创建文件
    @param String filePath 文件路径
    @param Function callback 创建结果回调函数

    */
    function create(filePath,callback){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            callback = argObj.callback;
        }
        var optId = getOptionId();
        if(isFunction(callback)){
            uexFileMgr.cbCreateFile = function(optId,dataType,data){
                if(dataType != 2){
                    return callback(new Error('create file error'),
                    data,dataType,optId);
                }
                callback(null,data,dataType,optId);
            };
        }
        uexFileMgr.createFile(optId,filePath);
        close(optId);
    }
    
    /*
    创建文件
    @param String filePath 创建一个加密文件
    @param String key 加密的字符串 
    @param Function callback 创建结果回调函数

    */
    function createSecure(filePath,key,callback){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            key = argObj.key;
            callback = argObj.callback;
        }
        key = key?key:'';
        var optId = getOptionId();
        if(isFunction(callback)){
            uexFileMgr.cbCreateSecure = function(optId,dataType,data){
                if(dataType != 2){
                    return callback(new Error('create secure file error'),
                    data,dataType,optId);
                }
                callback(null,data,dataType,optId);
            };
        }
        uexFileMgr.createSecure(optId,filePath,key);
        close(optId);
        
    }
    

    //本地文件
    var localPath = 'wgt://data/locFile.txt';

    /*
    删除本地文件
    @param Function callback 删除本地文件

    */

    function deleteLocalFile(callback){
        if(isPlainObject(callback)){
            callback = callback.callback;
        }
        if(!isFunction(callback)){
            callback = function(){};
        }
        deleteFile(localPath,callback);
    }

    /*
    写入本地文件
    @param String content 要写入的内容
    @param Function callback 写完后的结果

    */

    function writeLocalFile(content,callback){
        exists(localPath,function(err,data){
            if(err){
                return callback(err);
            }
            if(!data){
                create(localPath,function(err,res){
                    if(err){
                        return callback(err);
                    }
                    if(res == 0){
                        write(localPath,content,callback);
                    }
                });
            }else{
                write(localPath,content,callback);
            }
        });
    }

    /*
    读本地文件内容
    @param Function callback 结果回调


    */

    function readLocalFile(callback){
        return read(localPath,callback);
    }
    
    /*
    获取文件的真实路径
    @param String path 要获取的文件路径
    @param Function callback 获取成功后的回调    
    
    */
    function getRealPath(filePath,callback){
        var argObj = null;
        if(arguments.length === 1 && isPlainObject(filePath)){
            argObj = filePath;
            filePath = argObj.filePath;
            callback = argObj.callback;
        }
        uexFileMgr.cbGetFileRealPath = function(optId, dataType, data){
            if(dataType != 0){
                callback(new Error('get file path error'),data,dataType,optId);
                return;
            }
            callback(null,data,dataType,optId);
        };
        
        uexFileMgr.getFileRealPath(filePath);
    }
    
    
    
    
   var module = {
        wgtPath:'wgt://',
        resPath:'res://',
        wgtRootPath:'wgtroot://',
        open:open,
        close:close,
        read:read,
        readJSON:readJSON,
        write:write,
        create:create,
        remove:deleteFile,
        append:append,
        exists:exists,
        stat:stat,
        deleteLocalFile:deleteLocalFile,
        writeLocalFile:writeLocalFile,
        readLocalFile:readLocalFile,
        getRealPath:getRealPath,
        createSecure:createSecure,
        openSecure:openSecure,
        readSecure:readSecure,
        writeSecure:writeSecure,
        appendSecure:appendSecure
    };
    
    return module;

}());;


// 读写配置
/** 读取配置 **/
function getConfig(key, callback) {
	try {
		if (uexWidgetOne.platformName.toLowerCase().indexOf("simulator") >= 0) {
			callback(null, "");
			return;
		}
		
		var filePath = 'wgt://config.json';
		
		//判断文件config.json是否存在
		hjFile.exists({
			filePath: filePath,
			callback: function(err, data, dataType, optId){
				if (callback) {
					if (err) {
						callback(err, "");
						return;
					}
					if (data == 1) { // 1 存在
						try {
							// 读取配置
							hjFile.readJSON({
								filePath: filePath,
								callback: function(err, res){
									if (err) {
										console.log("文件不存在")
										callback(null, "");
										return;
									}
									
									callback(err, res[key] || "");
								}
							});
						}catch(e){
							callback(null, "");
						}
					}else {
						callback("文件不存在", "");
					}
				}
			}
		});
	}catch(e){
		callback(null, "");
	}
}


/** 写入配置 **/
function setConfig(key, value, callback) {
    
    var filePath = 'wgt://config.json';
    
    //判断文件config.json是否存在
    hjFile.exists({
        filePath: filePath,
        callback: function(err, data, dataType, optId){
            
            if (err) {
                callback ? callback(err) : null;
                return;
            }
            
            if (data == 1) { // 1 存在
                // 读取配置
                hjFile.readJSON({
                    filePath: filePath,
                    callback: function(err, config){
                        if (err) {
                            callback ? callback(err):null;
                            return;
                        }
                        
                        // 设置值
                        config[key] = value;
                        // writeConig
                        writeConfig(filePath, config, callback)
                        
                    }
                });
            } else {
                var config = {};
                config[key] = value;
                writeConfig(filePath, config, callback)
            }
            
        }
    });
    
}

/** 删除配置 **/
function removeConfig(key, callback) {
    
    var filePath = 'wgt://config.json';
    
    //判断文件config.json是否存在
    hjFile.exists({
        filePath: filePath,
        callback: function(err, data, dataType, optId){
            
            if (err) {
                callback ? callback(err) : null;
                return;
            }
            
            if (data == 1) { // 1 存在
                // 读取配置
                hjFile.readJSON({
                    filePath: filePath,
                    callback: function(err, config){
                        if (err) {
                            callback ? callback(err):null;
                            return;
                        }
                        
                        // 删除值
                        delete config[key];
                        // writeConig
                        writeConfig(filePath, config, callback)
                        
                    }
                });
            } 
            
        }
    });
    
}

function writeConfig(filePath, config, callback){
    // 写入文件
    hjFile.write({
        filePath: filePath,
        content: JSON.stringify(config),
        callback: function(err){
            if (err) {
                callback ? callback(err): null;
                return;
            }
        }
    });
}