/**初始化头像处理相关参数*/
var uploadHttp = global.SERVER_URL + "/yisuibao/user/userset/uploadImg.do?cPkId=";
var upload_image_url = "";
//选择照片后的本地路径
var server_url = "";
//图片上传成功后的地址，用于保存
var initCacheFlag = false;
var cur_phtot_user_id = "";
var fwk_op_code = 1;
var callFun = null,
    srcId = "",
    multiImg = false,
    maxImgNum = 10,
    isCropper = false,
    quality = 0.5;
//是否打开裁剪功能
var divPre = "",
    divSuf = "";
//图片显示的DIV的名称前缀和后缀，"_"符号隔开
var multiPaths = [],
    multiLen = 0;
function initImageParam() {
    //初始化缓存状态
    initCache();
    //拍照后的回调
    uexCamera.cbOpen = function(opCode, dataType, data) {
        if (isCropper) {
            var croParam = {
                src : data,
                quality : quality
            };
            uexImage.openCropper(JSON.stringify(croParam));
        } else {
            upload_image_url = data;
            upload(data, srcId);
        }
    };

    //选择相片后的回调
    uexImage.onPickerClosed = function(info) {
        info=JSON.parse(info);
        if (!info["isCancelled"]) {
            var data = info["data"];
            upload_image_url = data[0];
            if (data[0]) {
                if (multiImg) {
                    var divNames = srcId.split("_");
                    if (divNames.length > 1) {
                        divPre = divNames[0];
                        divSuf = divNames[divNames.length - 1];
                    }
                    multiPaths = data;
                    upload(multiPaths[0], divPre + "_" + (divSuf++));
                } else {
                    if (isCropper) {
                        var croParam = {
                            src : data[0],
                            quality : quality
                        };
                        uexImage.openCropper(JSON.stringify(croParam));
                    } else {
                        upload(data[0], srcId);
                    }
                }
            }
        }
    };

    //裁剪图片后的回调
    uexImage.onCropperClosed = function(info) {
        info=JSON.parse(info);
        if (!info["isCancelled"]) {
            var data = info["data"];
            upload_image_url = data;
            upload(data, srcId);
        }
    };
}

/**选择拍照或从照片选择后的回调方法*/
function selImgCall(data) {
    if (data == 0) {
        if (!multiImg) {
            maxImgNum = 1
        }
        var param = {
            min : 0,
            max : maxImgNum,
            quality : quality
        };
        uexImage.openPicker(JSON.stringify(param));
    } else if (data == 1) {
        uexCamera.open();
    }
}

/**调用上传*/
function upload(imgPath, divImgShowID) {
    uexUploaderMgr.cbCreateUploader = function(opCode, dataType, data) {
        if (data == 0) {
            uexUploaderMgr.uploadFile(opCode, imgPath, "filename", 3);
        }
    };
    uexUploaderMgr.onStatus = function(opCode, fileSize, percent, serverPath, status) {
        switch (status) {
        case 0:
            tipLoading(percent + "%");
            break;
        case 1:
            closeTip();
            uexUploaderMgr.closeUploader(opCode);
            if (!serverPath) {
                tip("上传失败");
                return;
            }
            server_url = serverPath;
            if (!multiImg) {
                setImg(imgPath);
            }
            if (getUserId() === cur_phtot_user_id) {
                updateFwkUser("cImg", serverPath);
                updateUserSet("cImg", serverPath);
            }
            //当随检用户就是当前用户时才更新主页头像
            if (getSuijianUserId && (getLocVal("archive-baseinfo.cUserId")||getSuijianUserId()) == getUserId()) {
                updateSuijianUser("cImg", serverPath);
                uexWindow.evaluateScript("main-main", 0, "showUser()");
            }
            if (callFun) {
                callFun(divImgShowID, server_url, imgPath);
                if (multiImg && multiLen < multiPaths.length - 1) {
                    upload(multiPaths[++multiLen], divPre + "_" + (divSuf++));
                }
            }
            break;
        case 2:
            closeTip();
            tip("上传失败");
            uexUploaderMgr.closeUploader(opCode);
            break;
        }
    };
    uexUploaderMgr.createUploader(++fwk_op_code, uploadHttp);
    //开始上传
}

/**上传后设置图像*/
function setImg(url, imgId) {
    if (!imgId) {
        imgId = "userImg";
    }
    if ($$(imgId)) {
        $$(imgId).src = url;
    }
}

/**
 * 根据性别设置背景图片
 * @param {Object} type 0：患者用户 1：医生
 * @param {Object} cSex 0：男 1：女
 * @param {Object} id
 */
function setBgImg(type, cSex, id) {
    if (type == null || type == undefined || type === "") {
        return;
    }
    if (cSex == null || cSex == undefined || cSex === "") {
        cSex = 0;
    }
    if (!id) {
        id = "userImg";
    }
    if ($$(id)) {
        var tmp = type == 0 ? "user" : "doctor";
        var result = "img-" + tmp + cSex;
        var regExp = new RegExp("img-" + tmp + "[-]?[\\w]+");
        var match = $$(id).className.match(regExp);
        if (match) {
            $$(id).className = $$(id).className.replace(regExp, result);
        } else {
            $$(id).className += " " + result;
        }
        $$(id).src = "../css/project/images/pixel.gif";
    }

}

/**
 *打开图像选择菜单
 * @param id 打开操作菜单的页面ID
 * @param _srcId 要显示的页面img元素ID
 * @param  _callFun 上传后的回调方法
 * @param _multiImg 是否支持多图片选择 ,定义多图片选择时打开系统相册图片时_isCropper参数无效
 * @param _maxImgNum 能选择的图片数
 * @param _quality 图片压缩比例
 * @param _isCropper 是否打开裁剪功能
 */
function openImgDialog(id, _srcId, _callFun, _multiImg, _maxImgNum, _quality, _isCropper) {
    if (!id) {
        return;
    }
    srcId = _srcId;
    callFun = _callFun;
    multiImg = _multiImg;
    isCropper = _isCropper;
    if (multiImg && isDefine(_maxImgNum) && !isNaN(_maxImgNum) && _maxImgNum > 0 && _maxImgNum < 20) {
        maxImgNum = _maxImgNum;
    }
    if (isDefine(_quality) && !isNaN(_quality) && _quality >= 0 && _quality <= 1) {
        quality = _quality;
    }
    openSelectPop(id, global.DIC_IMG_UPLOAD, 'selImgCall', '', '', '', '');
}

/**打开多图像选择菜单*/
function openMultiImgDialog(id, _srcId, _callFun, _maxImgNum, _quality, _isCropper) {
    //图片显示DIV规则：名称_序号
    openImgDialog(id, _srcId, _callFun, true, _maxImgNum, _quality, _isCropper);
}

/**当需要在上传成功后同时更新系统表的cImg字段时需设置该值，当前用户的cUserId*/
function setImgUserId(id) {
    if (!id) {
        return;
    }
    cur_phtot_user_id = id;
    uploadHttp += id;
}

/**获取本地缓存中的图片并设置为背景*/
function setCacheBackImg(id, url, width) {
    if (!id || !url) {
        return;
    }
    initCache();
    var remoteUrl = "";
    if (width) {
        remoteUrl = tool.getFwkShowImgPath(url, true, "limited", width);
    } else {
        remoteUrl = tool.getFwkShowImgPath(url, true, "specified", 300, 300);
    }
    zy_imgcache(id, global.PUBLIC_VERSION+"-"+url, remoteUrl);
}

/**初始化缓存*/
function initCache() {
    if (!initCacheFlag) {
        zy_initcache();
        initCacheFlag = true;
    }
}

function getSexValue(sex) {
    if (sex === null || sex === undefined || sex === "") {
        return 0;
    } else {
        return sex;
    }
}

/**修改上传地址*/
function setUploadUrl(url) {
    uploadHttp = url;
}

/**
 * 点击查看大图
 * @param {Object} url 本地缓存的url
 */
function viewImg(url) {
    if (!isDefine(url)) {
        return;
    }
    var param = {
        displayActionButton : true,
        displayNavArrows : true,
        enableGrid : true,
        data : [{
                    src : url
               }]
    };
    uexImage.onBrowserClosed = function() {

    };
    uexImage.openBrowser(JSON.stringify(param));
}

