function initPush() {
    try {
		
        uexJPush.onReceiveNotificationOpen = onReceiveNotificationOpen;
		uexJPush.onReceiveNotification = onReceiveNotification;
		uexJPush.disableLocalNotificationAlertView(1);
        if (isPushEnable()) {
            uexJPush.resumePush();
        }
    } catch(e) {
        
    }
}

var openNotify = false;
var isOpenProcessed = false;
var data;
var retryCount = 5;
var retryPeriod = 2000;

function openPushNotify() {
	openNotify = true;
}

function onReceiveNotificationOpen(info) {
    data = JSON.parse(info);
	if (isOpenProcessed) {
		processPush()
	} else {
		setTimeout("openProcessPush()", retryPeriod);
	}
}

/**
 * APP 启动处理推送 
 */
function openProcessPush() {
	
	if(!openNotify && retryCount >= 0) {		// APP启动中，并且还有重试次数
		--retryCount;
		setTimeout("openProcessPush()", retryPeriod);
		return;
	}
	
	// 处理过了
	if(isOpenProcessed) {
		return;
	}
	
	// 处理
	processPush();
	
	// 设置已处理过
	isOpenProcessed = true;

}





/**
 * 处理推送
 */
function processPush() {
	
	try {
		// 获得扩展参数
        var extras = data["extras"];
		
        switch(extras["type"]) {
        case "1":
            // 签约
            setLocVal("sign-sign_details.cPkId", extras["sign-sign_details.cPkId"]);
            openWin("sign/sign_details")
            break;
        case "2":
            // 转诊
            break;
        case "3":
            // 挂号
            break;
        case "4":
            // 醫生信息
			setLocVal("doctor_info.doctId", extras["doctor-doctor_info.doctId"]);
			openWin('doctor/doctor_info');
            break;
		case "5":
            // 医生预约
			setLocVal("appoint-appoint_edit.cPkId", extras["appoint-appoint_edit.cPkId"]);
			setLocVal("appoint-appoint_edit.cStatus", extras["appoint-appoint_edit.cStatus"]);
            openWin('appoint/appoint_edit');
            break;
		 case "6":
            // 医生关注
			setLocVal("doctor_info.doctId", extras["doctor-doctor_info.doctId"]);
            openWin('doctor/doctor_info');
            break;
        }
	} catch(e) {
       console.log(e);
    }

}

/**
 * 收到通知
 */
function onReceiveNotification(info) {
	var notifyData = JSON.parse(info);
	// 处理推送消息信息
	processData(notifyData);
	
}

/**
 * 推送消息信息
 */
var pushData = {};

/**
 * 处理推送消息信息
 */
function processData(notifyData) {
	try {
		var pushTag = notifyData["extras"]["tag"];
		if(pushTag) {
			var tagData = pushData[pushTag];
			if(tagData) {	// 存在目标tag
				var pushMaxCount = parseInt(notifyData["extras"]["maxCount"]);
				if(tagData.ids && pushMaxCount <= tagData.ids.length && tagData.ids.length > 0) {		// 如果id数量达最大值，删除一个最久远的id
					var removedId = tagData.ids.shift()		// 从数组删除id并返回
					uexJPush.clearNotificationById(JSON.stringify({notificationId:removedId}));		// 清楚该条推送
				} 
				// 添加id进入数组
				tagData.ids.push(notifyData.notificationId);
				
			} else {	
				pushData[pushTag] = {
					ids: [notifyData.notificationId]
				};
			}
			
		}
		
	} catch(e) {
		alert(e)
	}
}
