
/**
 * 扫描医随宝所有类型二维码
 * 医随宝二维码规则:
 * 1、用户二维码=ysb_u_随宝号
 * 2、血压计上二维码=ysb_d1ccxx_厂商设备imie码
 * 3、血糖仪上二维码=ysb_d2ccxx_厂商设备imie码
 * 4、电视上二维码=ysb_dtccxx_电视卡imie码
 * d1,d2,d3用来区分不同设备类型，1为血压计，2为血糖仪,，t为电视卡。
 * cc为2位数字，代表厂商编码，区分不同厂商，如正康公司的厂商代码为01。
 * xx为2位数字，代表该设备型号，从01开始，用来区分同一个厂商的多款血压计，如果该厂商的多款血压计的imie码不重复，则该编码可不变。
 * 二维码转换成设备序号格式：zccxx厂商设备imie码

 */
function openScanner(){
	scanBizQrCode(function(bizType,bizValue,qrCode){
         if ("u" == bizType) {//用户二维码
         	chekBizNo(bizValue,function(isSuccess,bizNo,data){
				if (isSuccess) {
					setLocVal('user-user_qrcode_bizNo', bizNo);
					openWin('../family/fami_select');
				}else{
					tip("不能加载用户信息");
				}
			});
		}else if (bizType.indexOf("d")==0) {//设备二维码
			if (bizType.indexOf("d2")==0) {//绑定血糖仪二维码
				setLocVal('apparatus_manage_bound_num',bizValue);
				setLocVal('apparatus_manage_bound_type','2');
				openWin("../apparatus/apparatus_manage");
			}else if (bizType.indexOf("d1")==0) {//绑定血压计二维码
				setLocVal('apparatus_manage_bound_num',bizValue);
				setLocVal('apparatus_manage_bound_type','1');
				openWin("../apparatus/apparatus_manage");
			}else if (bizType.indexOf("dt")==0) {//电视上二维码
				checkTvCardValid(bizValue);
			}
		}else if(bizType.indexOf("ter")==0 ){//终端机交挂号费扫码
			var typeInfo=bizType.split("-");
			setLocVal('hosp-pati_list_scan.scanType',typeInfo[0]);
			setLocVal('hosp-pati_list_scan.hospKey',typeInfo[1]);
			setLocVal('hosp-pati_list_scan.qrCode',qrCode);
			openWin("../hosp/pati_list_scan");
		}else if(bizType.indexOf("reg")==0 ){//业务注册入口
			var typeInfo=bizType.split("-");
			setLocVal('hosp-pati_list_scan.scanType',typeInfo[0]);
			setLocVal('hosp-pati_list_scan.hospKey',typeInfo[1]);
			setLocVal('hosp-pati_list_scan.qrCode',qrCode);
			setLocVal('hosp-pati_list_scan.patiId','');
			if (isLogin()) {
				//已登录时直接选择就诊人
				openWin("../hosp/pati_list_scan");
			}else {
				openWin("../hosp/hosp_login");//未登录时注册、登录并查询
			}
		}else if(bizType.indexOf("ud")==0 ){//医生扫码,"udsign"为签约医生
			if ("udsign" == bizType) {
				setLocVal('hosp-pati_list_scan.qrCode', qrCode);
				setLocVal("doctor-doctor_info.hasDoc","Y");
				openWin("../sign/sq_sign_pati_select");
			}else{
	         	chekBizNo(bizValue,function(isSuccess,bizNo,data){
					if (isSuccess) {
						var doctId=data.custDataStr;
						if (doctId) {
							setLocVal("doctor_info.doctId", doctId);
							openWin('../doctor/doctor_info');
						}else{
							tip("不能加载医生信息");
						}
						
					}else{
						tip("不能加载医生信息");
					}
				});
				
			}
		}else{
			tip("不支持此二维码，请升级医随宝版本后重试");
		}
	},"将二维码放入取景框中即可自动扫描","医随宝扫一扫",'','');
}
/**
 * 随宝号是否有效
 */
function chekBizNo(bizNo,cbFun) {
	var url = global.SERVER_URL + "/yisuibao/user/userset/chekBizNo.do?actionType=act";
	var param = [{
		'key' : 'ajax',
		'type' : '0',
		'value' : 'mobile'
	}, {
		'key' : 'voId',
		'type' : '0',
		'value' : bizNo
	}];
	$.getJSON(url, function(data) {
		dealResult(data, function(data) {
			if(cbFun){cbFun(true,bizNo,data)};
            
		}, function(data, result) {
			if (cbFun) {
				cbFun(false,bizNo, data);
			}
			else {
				tip(result.resultMsg.substring(result.resultMsg.indexOf('\n') + 1));
			}
		});
	}, "json", function() {if (cbFun) {cbFun(false,bizNo,data);}
	}, "POST", param, false);
}
	
function checkTvCardValid(tvCardNo){
    var url = global.SERVER_URL + "/yisuibao/user/userset/checkTvCard.do?actionType=act";
    var param = [{
        'key': 'ajax',
        'type': '0',
        'value': 'mobile'
    }, {
        'key': 'tvCardNo',
        'type': '0',
        'value': tvCardNo
    }];
    $.getJSON(url, function(data){
        dealResult(data, function(data){
            if (data.custDataStr&&data.custDataStr=="true") {
				setLocVal('family-bind_tv_select.cTvCardNo', tvCardNo);
				openWin("../family/bind_tv_select");
            }else{
				alertMsg("扫码识别的电视卡号无效");
			}
        }, function(data, result){
			tip("检测电视卡号失败");
        });
    }, "json", getJSONError, "POST", param, false);
}