/**
 * FwkTool，封装的工具类
 */
function FwkTool(){
	this.LOAD_DELAY_TIME = 100;
	this.isAppCan = false;
	this.ready = null;//适配appcan环境和纯web页面的
	this._clearReady = null;
	this.init=tool_init;
	this.getFontSize=tool_getFontSize;//获取自适应字体值大小
	this.con=tool_con;
	this.getIframeDoc=tool_getIframeDoc;//获取iframe的Document的dom对象
	this.getFwkFilePath=tool_getFwkFilePath;//获取文件服务器的文件路径
	this.getFwkShowImgPath=tool_getFwkShowImgPath;//获取文件服务器显示图片路径
	this.fwkDelete=tool_fwkDelete;//文件服务器文件删除的方法
	this.isErrorResult=tool_isErrorResult;//返回的json对象的是否失败
	this.getCodelistJson=tool_getCodelistJson;//获取json格式的codelist数据
	this.getCodelistArray=tool_getCodelistArray;//获取数组格式的codelist数据
	this.getEmSize=tool_getEmSize;//获取1em的像素值
	
	function tool_init(){
		var fontSize=window.localStorage["defaultfontsize"];
		if (!fontSize) {
			fontSize = this.getFontSize();
			document.body.style.fontSize = fontSize+"px";
			document.styleSheets[0].addRule("body","font-size:"+fontSize+"px;"); 
			//window.localStorage["defaultfontsize"] = fontSize;
		}else {
			if (window.navigator.platform == "Win32") {
				document.body.style.fontSize = fontSize;
			}
		}
	}
	function tool_getEmSize(){
		var fontSize=window.localStorage["defaultfontsize"];
		if (!fontSize) {
			fontSize=document.body.style.fontSize;
			if (!fontSize) {
				fontSize=tool_getFontSize();
			}
		}
		if (fontSize && (fontSize+'').indexOf('px')>0) {
			fontSize=fontSize.substring(0,fontSize.length-2);
		}
		return fontSize;
	}
	function tool_getFontSize(){
		var width=document.body.clientWidth<document.body.clientHeight?document.body.clientWidth:document.body.clientHeight;
		var fontSize=16;
		if(width){
			width+=3;
			if(width<=360){
				fontSize=16; //16
			}else if(width<=410){
				fontSize=18;//google nexus4
			}else if(width<=520){
				fontSize=21;//苹果手机iphone6plus上的字体为21,原为24
			}else if(width<=600){
				fontSize=24;//32
            }else if(width<=680){
				fontSize=28;//google Nexus7：600*960
            }else if(width<=750){
				fontSize=36;//M2尺寸720*1280或者红米note,原为36
            }else if(width<=840){
				fontSize=44;//google nexus10
			//}else if(width<=940){
				//fontSize=29;//Laptop with HiDPI screen 1440*900
			}else if(width<=1120){
				fontSize=54;//M3尺寸1080*1920, fontSize=(width/200).toFixed(0)*10;
			}else if(width<=1480){
				fontSize=60;//5.7英寸，乐视1440-2560，此处首页未起到作用但ui-media.css发生作用。其他页面有起作用（如全部服务，随行百科）。
			}
			else if(width<=2200){
				fontSize=(width/200).toFixed(0)*10;//三星s60：2560-1440,索尼Xperia Z5 Premium：3840x2160
			}//else if(width<=1480){
				//fontSize=30;//Laptop with hidpi screen}
			else{
				fontSize=54;// M3尺寸1080*1920, fontSize=(width/200).toFixed(0)*10;
			}
		}
		return fontSize;
	}

	function tool_con(id,url){
		var s=window.getComputedStyle($$(id),null);
		var ifId=url.substring(url.indexOf("/")>=0?url.lastIndexOf("/"):0,url.indexOf(".")>0?url.lastIndexOf("."):url.length);
		var html='<iframe style="border-width: 0px; position: absolute; left: 0px; top: 0px; width: 100%; height: 100%; z-index: 101;" src="'+url+'" name="'+ifId+'" id="'+ifId+'"></iframe>'
		$$(id).innerHTML=html;
		var subDoc=this.getIframeDoc(ifId);
		subDoc.body.style.fontSize = s.fontSize+"px";
		//subDoc.styleSheets[0].addRule("body","font-size:"+fontSize+"px;"); 
	}
	
	function tool_getIframeDoc(id){
        return document.getElementById(id).contentDocument || document.frames[id].document;
    }
	
	
	/**
	 * 获取文件服务器文件下载的路径
	 * @param filePath 文件路径字符串
	 * @return 请求服务器URL
	 */
	function tool_getFwkFilePath(filePath){
		var actionUrl=global.FILE_SERVER_URL+"/fwkDownloadFile.ag";//默认请求文件服务器上传服务
		var seperateStr=(actionUrl.indexOf("?")<0)?"?":"&";
		actionUrl=actionUrl+seperateStr+"method=downloadFile&path="+encodeURI(encodeURI(filePath))+"&fwkRandom="+new Date().getTime();
		return actionUrl;
	}
	
	/**
	 * 获取文件服务器显示图片路径
	 * @param filePath 文件路径字符串
	 * @param isCompress 是否压缩图像,用于生成缩略图,可为空，默认不压缩图像
	 * @param compressMode 压缩模式
	 * limited=限制大小模式,自适应大小，为默认值，当请求宽度和高度两者缺一个时，按原图像长宽比例取另外一个值，当都有时，自动选择最大的高度或宽度，取最合适大小，保持原始图像长宽比例
	 * specified=指定尺寸模式，当请求宽度和高度两者缺一个时，按原图像长宽比例取另外一个值，当都有时，按照指定高度和宽度，可能改变原始图像长宽比例
	 * percentage=指定比例缩放模式，按指定比例缩放
	 * @param width 宽度像素值
	 * @param height 高度像素值
	 * @param rate 缩放比例小数表示
	 * @return 无返回值
	 */
	function tool_getFwkShowImgPath(filepath,isCompress,compressMode,width,height,rate){
		filepath = encodeURIComponent(encodeURIComponent(filepath));
		var src_path = global.FILE_SERVER_URL+"/showImage.ag?method=showImage&path="+filepath;
		if(isCompress){
			compressMode=(compressMode!="specified" && compressMode!="percentage" )?"limited":compressMode;
			width=(width==null)?"":width;
			height=(height==null)?"":height;
			rate=(rate==null)?"":rate;
			src_path = src_path+"&width="+width+"&height="+height+"&compressMode="+compressMode+"&rate="+rate;
		}
		return src_path;
		
	}
	
	/**
	 * 文件服务器文件删除的方法，此方法基于JQuery
	 * 方法需在JSP页面中配置 <fwk:deploy/>标签以获得文件服务器URL
	 * @param filePath 文件路径字符串
	 * @return 无返回值
	 */
	function tool_fwkDelete(filePath){
		var actionUrl=global.FILE_SERVER_URL+"/deleteFile.ag";//默认请求文件服务器删除服务
		var seperateStr=(actionUrl.indexOf("?")<0)?"?":"&";
		actionUrl=actionUrl+seperateStr+"method=deleteFile&path="+encodeURI(encodeURI(filePath))+"&fwkRandom="+new Date().getTime();
		$.getJSON(actionUrl, function(data){
			/*
			dealResult(data,function(data){
			},function(data,result){
	   		});
	   		*/
		},"",function(){}, "GET", "", false);
		return true;//默认删除成功
	}

	
	/**
	 * @desc:返回的json对象的是否失败
	 */
	function tool_isErrorResult(data){
		if(data==null || data=="undefined" ){
			return true;
		}
		var dataObj=null;
		try{
			if(typeof(data)=="object"){
				dataObj=data;
			}else{
				dataObj=eval('('+data+')');
			}
		}catch(e){
			return true;
		}
		
		return false;
	}
	
	/**
	 * 获取json格式的codelist数据
	 * @param codeListName codelist的名称
	 * @param codeKind 可选，codelist的分类
	 * @param params 可选，json字符串或json对象,codelist的参数
	 * @param callBackFun 可选，回调函数
	 */
	function tool_getCodelistJson(codeListName,codeKind,params,callBackFun){
		if(!codeListName){return;}
		var tmp_json;
		var param =[{'key':'ajax','type':'0','value':'mobile'},
		{'key':global.CODELIST_NAME,'type':'0','value':encodeURIComponent(codeListName)}];
		if(codeKind !="undefined" && codeKind !=null && codeKind !=""){
			param.push({'key':global.CODELIST_KIND,'type':'0','value':encodeURIComponent(codeKind)});
		}
		if(params){
			//param.push({'key':global.CODEKIND_PARAMS,'type':'0','value':encodeURIComponent(params)});
			param.push({'key':global.CODEKIND_PARAMS,'type':'0','value':params});
		}
	    var url =global.SERVER_URL+"/service/fwk/codelist/getJsonOptions.do";
	    $.getJSON(url, function(data){
			if(tool.isErrorResult(data)){
       			tmp_json=null;
       		}else{
				var dataObj=data;
				if(typeof(data)!="object"){
					dataObj=eval('('+data+')');
				}
	       		tmp_json=dataObj.options;
       		}
			if (callBackFun) {
				callBackFun(tmp_json);
			}
	    }, "json",getJSONError, "POST", param, false);
	}
	/**
	 * 获取数组格式的codelist数据
	 * @param codeListName codelist的名称
	 * @param codeKind 可选，codelist的分类
	 * @param params 可选，json字符串或json对象,codelist的参数
	 * @param callBackFun 可选，回调函数
	 */
	function tool_getCodelistArray(codeListName,codeKind,params,callBackFun){
		this.getCodelistJson(codeListName,codeKind,params,function(data){
			var arr=[];
			if(data){
				for(var key in data){
					arr.push({'value':key,'name':data[key]});
				}
				data=arr;
			}
			if (callBackFun) {
				callBackFun(data);
			}
			
		});
	}
}
var tool = new FwkTool();


(function(win){
	//是否在APPCAN中打包运行
	tool.isAppCan=false;
	
	//ready封装
	var _appCanReady=[],_doFun=false;
	tool.ready=function(callbackFun){
		_appCanReady.push(callbackFun);
	};
	tool._clearReady=function(){
		_appCanReady=[];
	};
	window.uexOnload=function(type){
		if(!type){
			tool.isAppCan=true;
			_doFunction(type,true);
		}
	};
	window.onload=function(){
		var time=(top && top.document && top.document.getElementById("mobileScreen"))?2000:tool.LOAD_DELAY_TIME;
		setTimeout(function(){
			_doFunction('',false);
		},time);
	}
	
	function _doFunction(type,isAppCan){
		if(_doFun)return;
		for(fn in _appCanReady){
			_appCanReady[fn].call(window,type,isAppCan);
		}
		_doFun=true;
	}
	
	
})(window);