
/**
 * 获得小区
 */
var getCmt = function(){
	var cmt;
    var userId = getUserId();
	var flag = isLogin();
    if (flag && userId) {
       cmt = getLocVal('yisuibao.cmt.login.' + userId);
	   if(!cmt){
	   		var user=getUser();
			if(user){
				cmt=user.cCmtId;
				setLocVal('yisuibao.cmt.login.' + userId,cmt);
			}
	   }
    }
    else {
       cmt =  getLocVal('yisuibao.cmt.nologin');
    }
	
	return cmt;
}


/**
 * 获得登录用户的默认小区
 */
var getUserCmt = function(){
	var cmt;
    var userId = getUserId();
	var flag = isLogin();
    if (flag && userId) {
       cmt = getLocVal('yisuibao.cmt.login.' + userId);
	   if(!cmt){
	   		var user=getUser();
			if(user){
				cmt=user.cCmtId;
				setLocVal('yisuibao.cmt.login.' + userId,cmt);
			}
	   }
    }
	
	return cmt;
}

/**
 * 选择小区
 * @param {Object} cCmtId		社区id
 */
var selectCmt = function(cCmtId){
	
    var userId = getUserId();
	var flag = isLogin();
    if (flag && userId) {
        setLocVal('yisuibao.cmt.login.' + userId, cCmtId);
	        updateCmt(userId, cCmtId);			
    }
    else {
        setLocVal('yisuibao.cmt.nologin', cCmtId);
    }
	
}

/**
 * 设置小区
 * @param {Object} cCmtId		社区id
 */
var setCmt = function(cCmtId){
	
    var userId = getUserId();
	var flag = isLogin();
    if (flag && userId) {
		if (!cCmtId) {
			clearLocVal('yisuibao.cmt.login.' + userId);
		}else {
			setLocVal('yisuibao.cmt.login.' + userId, cCmtId);
		}
    }
    else {
		if (!cCmtId) {
			clearLocVal('yisuibao.cmt.nologin' );
		}
		else {
			setLocVal('yisuibao.cmt.nologin', cCmtId);
		}
    }
	
}

var updateCmt = function(userId, cCmtId){
	var userSet = getLocJson('fwk_user_set');
	if(userSet.cUserId!=userId || cCmtId ==userSet.cCmtId ){
		return;
	}
    var url = global.SERVER_URL + "/yisuibao/user/userset/appUpdate.do?actionType=act&voId=" + userSet.cPkId;
    var param = [{
        'key': 'ajax',
        'type': '0',
        'value': 'mobile'
    }, {
        'key': 'vo.cCmtId',
        'type': '0',
        'value': cCmtId
    }, {
        'key': 'vo.cUserId',
        'type': '0',
        'value': userId
    }];
    $.getJSON(url, function(data){
        dealResult(data, function(data){
            userSet.cCmtId=cCmtId;
			setLocJson('fwk_user_set',userSet);
        }, function(data, result){
            uexWindow.toast("0", "5", result.resultMsg, 2000);
        });
    }, "json", getJSONError, "POST", param, false);
}

//var setCity = function(value) {
//	setLocVal("user_locate.city",value);
//}

/**@auth pengjunming
 * 获取默认的城市代码
 */
function getDefaultCityCode(){
			return "0-0";
}

/**@auth pengjunming
 * 获取默认的城市名称
 */
function getDefaultCityName(){
			return "广州";
}

/**@auth pengjunming
 * 获取当前的城市编码
 */
function getCurrentCityCode(){
	var userId = getUserId();
	var flag = isLogin();
	var code = "";
    if (flag && userId) {
        code = getLocVal('yisuibao.city.code.login.' + userId);
    }
    else {
       code = getLocVal('yisuibao.city.code.nologin');
    }
	if(!code){
		code = getDefaultCityCode();
	}
	return code;
}

/**@auth pengjunming
 * 设置当前的城市编码
 */
function setCurrentCityCode(code){
	var userId = getUserId();
	var flag = isLogin();
	code = code || getDefaultCityCode();
		if (flag && userId) {
			setLocVal('yisuibao.city.code.login.' + userId, code);
		}
		else {
			setLocVal('yisuibao.city.code.nologin',code);
		}
}


/**@auth pengjunming
 * 设置当前的城市名称
 */
function setCurrentCityName(name){
	var userId = getUserId();
	var flag = isLogin();
	name = name || getDefaultCityName();
		if (flag && userId) {
			setLocVal('yisuibao.city.name.login.' + userId, name);
		}
		else {
			setLocVal('yisuibao.city.name.nologin',name);
		}
}

/**@auth pengjunming
 * 获取当前的城市名称
 */
function getCurrentCityName(){
	var userId = getUserId();
	var flag = isLogin();
	var name = "";
    if (flag && userId) {
        name = getLocVal('yisuibao.city.name.login.' + userId);
    }
    else {
       name = getLocVal('yisuibao.city.name.nologin');
    }
	if(!name){
		name = getDefaultCityName();
	}
	return name;
}

/**@auth pengjunming
 * 获取小区的json数据
 */
var getCmtJson = function(){
	var userId = getUserId();
    var flag = isLogin();
	var cmt;
    if (flag && userId) {
       cmt = getLocJson('yisuibao.cmt.json.login.' + userId);
    }
    else {
       cmt =  getLocJson('yisuibao.cmt.json.nologin');
    }
	
	return cmt;
}

/**@auth pengjunming
 * 保存小区的json数据
 */
var setCmtJson = function(cmt){
	var userId = getUserId();
	var flag = isLogin();
    if (flag && userId) {
		if (!cmt) {
			clearLocVal('yisuibao.cmt.json.login.' + userId);
		}
		else {
			setLocJson('yisuibao.cmt.json.login.' + userId, cmt);
		}
    }
    else {
		if (!cmt) {
			clearLocVal('yisuibao.cmt.json.nologin');
		}
		else {
			setLocJson('yisuibao.cmt.json.nologin', cmt);
		}
    }
	setCmt(cmt?cmt.cPkId:'');
	return cmt;
}

var saveCallHis = function(type,name,calledPhone){
			if(!calledPhone)return ;
			calledPhone = calledPhone.split(',') && calledPhone.split(',')[0];
			var userSet = getUserSet();
			var userId = 'anonymous';
			var phone = 'anonymous';
			var userName = getUserName();
			userName = userName || 'anonymous';
			if(userSet){
				userId = userSet.cPkId;
				phone = userSet.cMobile
			}
	    	var url = global.SERVER_URL + "/yisuibao/his/callhis/appAdd.do?actionType=act";
            var arrData;
            var param = [{
                'key': 'ajax',
                'type': '0',
                'value': 'mobile'
            }, {
                'key': 'vo.cUserId',
                'type': '0',
                'value': userId
            },  {
                'key': 'vo.cName',
                'type': '0',
                'value': userName
            },{
                'key': 'vo.cPhone',
                'type': '0',
                'value': phone
            }, {
                'key': 'vo.cCalledPhone',
                'type': '0',
                'value': calledPhone
            }, {
                'key': 'vo.cProviderType',
                'type': '0',
                'value': type
            }, {
                'key': 'vo.cProviderName',
                'type': '0',
                'value': name
            }];
            
            $.getJSON(url, function(data){
                dealResult(data, function(data, result){
                	
                }, function(data, result){
                    uexWindow.toast("0", "5", data.userData.resultMsg, 2000);
                    return;
                });
            }, "json", getJSONError, "POST", param, false);
}

var  call = function(number){
	if(!number)return ;
	number = number.replace(/\-/g, "").replace(/\s/g, "");//去掉空格和-
	var nums = number.split(',');
	var numsWithTip = [];
	for(var i = 0,length = nums.length;i<length;i++){
		numsWithTip[i] = '拨打号码 : '+nums[i];
	}
	var cancelIndex = nums.length;
	 uexWindow.cbActionSheet = function(opId,dataType,data){
      if(data == cancelIndex) return;
	  if (isNaN(nums[data])) {
		  uexWindow.toast("0", "5", '电话号码不合法', 2000);
		  return;
		}
		uexCall.call(nums[data]);
    }
    uexWindow.actionSheet("拨号","取消",numsWithTip);
	
}
	
