jQuery.extend(jQuery.validator.messages, {
  required: "必须填写",
  remote: "请修正该字段",
  email: "请输入正确格式的电子邮件",
  url: "请输入合法的网址",
  date: "请输入合法的日期",
  dateISO: "请输入合法的日期 (ISO).",
  number: "请输入合法的数字",
  digits: "只能输入整数",
  creditcard: "请输入合法的信用卡号",
  equalTo: "请再次输入相同的值",
  accept: "请输入拥有合法后缀名的字符串",
  maxlength: jQuery.validator.format("请输入一个 长度最多是 {0} 的字符串"),
  minlength: jQuery.validator.format("请输入一个 长度最少是 {0} 的字符串"),
  rangelength: jQuery.validator.format("请输入 一个长度介于 {0} 和 {1} 之间的字符串"),
  range: jQuery.validator.format("请输入一个介于 {0} 和 {1} 之间的值"),
  max: jQuery.validator.format("请输入一个最大为{0} 的值"),
  min: jQuery.validator.format("请输入一个最小为{0} 的值")
});
$(document).ready(function(){       
  
 // 字符验证       
 jQuery.validator.addMethod("stringCheck", function(value, element) {
	return this.optional(element) || /^[\u0391-\uFFE5\w]+$/.test(value);
}, "只能包括中文字、英文字母、数字和下划线");     

 //判断字符由字母和数字，下划线,点号组成.且开头的只能是下划线和字母
jQuery.validator.addMethod("isRegisterName", function(value, element,param) {  
	    var reg=/^([a-zA-z_]{1})([\.\w]*)$/g;
		 return this.optional(element) || reg.test(value);       
}, "只能输入以字母开头,可带数字、“_”、“.”的字串");
//判断字符由字母和数字，下划线组成.且开头的只能是下划线和字母
jQuery.validator.addMethod("isRegisterName2", function(value, element,param) {  
	    var reg=/^([a-zA-z_]{1})([\w]*)$/g;
		 return this.optional(element) || reg.test(value);       
}, "只能输入以字母开头,可带数字、“_”的字串");
jQuery.validator.addMethod("isEnglish", function(value, element,param) {  
    var reg=/[a-zA-z]/g;
	 return this.optional(element) || reg.test(value);       
}, "只能输入字母"); 
//特殊字符
jQuery.validator.addMethod("stringCheck2", function(value, element,param) {  
  	var reg= /[~#^$@%&!*"']/gi;
	 return this.optional(element) || !reg.test(value);       
}, "不能输入~、#、^、$、@、%、&、!、*、\"、'");
 // 只能输入整数 
 jQuery.validator.addMethod("numInteger", function(value, element,param) {   
	 var c = value.length-1;
	 return this.optional(element) || c < param && /^\d+$/.test(value);       
 }, "只能输入{0}位整数");  
 // 只能输入浮点数--请输入一个整数位{0}位小数{1}位小数
 jQuery.validator.addMethod("numFloat", function(value, element,param) {   
	 var re = new RegExp("^[\\d+]{1,"+param[0]+"}(\\.\\d{1,"+param[1]+"})?$") 
	 return this.optional(element) || re.test(value);       
 }, "请输入一个小数位有{1}个的浮点数");  
 // 只能输入浮点数--格式
 jQuery.validator.addMethod("numFloat2", function(value, element,param) {
	 var pvl = param+"";
	 var num1 = pvl.indexOf(".");
	 var num2 = pvl.substring(pvl.indexOf(".")+1, pvl.length).length;
	 var re = new RegExp("^[\\d+]{1,"+num1+"}(\\.\\d{1,"+num2+"})?$") ;
	 return this.optional(element) || re.test(value);       
 }, "只能输入浮点数--格式[{0}]");  

 // 中文字两个字节       
 jQuery.validator.addMethod("byteRangeLength", function(value, element, param) {       
     var length = value.length;       
     for(var i = 0; i < value.length; i++){       
         if(value.charCodeAt(i) > 127){       
         length++;       
         }       
     }       
	
     return this.optional(element) || ( length >= param[0] && length <= param[1] );       
 }, "请确保输入的值在{0}-{1}个字节之间(一个中文字算2个字节)"); 
 
 // 中文字两个字节 最大长度
 jQuery.validator.addMethod("byteMaxlength", function(value, element, param) {       
     var length = value.length;       
     for(var i = 0; i < value.length; i++){       
         if(value.charCodeAt(i) > 127){       
         length++;       
         }       
     }       
     return this.optional(element) || ( length <= param);       
 }, "请输入一个长度最多是{0}的字符串(一个中文字算2个字节)");   
   
 // 身份证号码验证       
 jQuery.validator.addMethod("isIdCardNo", function(value, element) {       
     return this.optional(element) || IdCardValidate(value);       
 }, "请正确输入您的身份证号码");    
      
 // 手机号码验证       
 jQuery.validator.addMethod("isMobile", function(value, element) {       
     var length = value.length;   
     //var mobile = /^(((13[0-9]{1})|(15[0-9]{1}))+\d{8})$/;  
     var mobile = /^(((1[0-9]{2}))+\d{8})$/;  
     return this.optional(element) || (length == 11 && mobile.test(value));       
 }, "请正确填写您的手机号码");       
      
 // 电话号码验证       
 jQuery.validator.addMethod("isTel", function(value, element) {       
     var tel = /^\d{3,4}-?\d{7,9}$/;    //电话号码格式010-12345678   
     return this.optional(element) || (tel.test(value));       
 }, "请正确填写您的电话号码");   
   
 // 联系电话(手机/电话皆可)验证   
 jQuery.validator.addMethod("isPhone", function(value,element) {   
     var length = value.length;   
     //var mobile = /^(((13[0-9]{1})|(15[0-9]{1}))+\d{8})$/;  
     var mobile = /^(((1[0-9]{2}))+\d{8})$/;  
     var tel = /^\d{3,4}-?\d{7,9}$/;   
     return this.optional(element) || (tel.test(value) || mobile.test(value));   
   
 }, "请正确填写您的联系电话");   
      
 // 邮政编码验证       
 jQuery.validator.addMethod("isZipCode", function(value, element) {       
     var tel = /^[0-9]{6}$/;       
     return this.optional(element) || (tel.test(value));       
 }, "请正确填写您的邮政编码");    
 /*
 jQuery.validator.addMethod("isLongitude", function(value, element) {   
// string patternLongitude = "^[EW]?((//d|[1-9]//d|1[0-7]//d)[//s//-,;°度](//d|[0-5]//d)[//s//-,;′分](//d|[0-5]//d)(//.//d{1,2})?[//s//-,;/"秒]?$)|(180[//s//-,;°度]0[//s//-,;′分]0[//s//-,;/"秒]?$)"; 
// var tel = /^-?(?:(?:180(?:\.0{1,5})?)|(?:(?:(?:1[0-7]\d)|(?:[1-9]?\d))(?:\.\d{1,5})?))$/;    
     var tel = /^(\d|[1-9]\d|1[0-7]\d)[\.\s\-,;°度](\d|[0-5]\d)[\.\s\-,;′分]\d{1,2}?[s\-,;\"秒]?$/;    
     ///^?(\d|[1-9]\d|1[0-7]\d)[\s\-,;°度](\d|[0-5]\d)[s-,;′分](\d|[0-5]\d)(\.\d{1,2})?[\s\-,;\"秒]?$/
     return this.optional(element) || (tel.test(value));       
 }, "请正确填写经度格式"); 
 jQuery.validator.addMethod("isLatitude", function(value, element) {    
	 // string patternLatitude = "^[NS]?((//d|[1-8]//d)[//s//-,;°度](//d|[0-5]//d)[//s//-,;′分](//d|[0-5]//d)(//.//d{1,2})?[//s//-,;/"秒]?$)|(90[//s//-,;°度]0[//s//-,;′分]0[//s//-,;/"秒]?$)"; 
     var tel = /^-?(?:90(?:\.0{1,5})?|(?:[1-8]?\d(?:\.\d{1,5})?))$/;       
     return this.optional(element) || (tel.test(value));       
 }, "请正确填写纬度格式"); */
});

/**  
 * 身份证15位编码规则：dddddd yymmdd xx p   
 * dddddd：地区码   
 * yymmdd: 出生年月日   
 * xx: 顺序类编码，无法确定   
 * p: 性别，奇数为男，偶数为女  
 * <p />  
 * 身份证18位编码规则：dddddd yyyymmdd xxx y   
 * dddddd：地区码   
 * yyyymmdd: 出生年月日   
 * xxx:顺序类编码，无法确定，奇数为男，偶数为女   
 * y: 校验码，该位数值可通过前17位计算获得  
 * <p />  
 * 18位号码加权因子为(从右到左) Wi = [ 7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2,1 ]  
 * 验证位 Y = [ 1, 0, 10, 9, 8, 7, 6, 5, 4, 3, 2 ]   
 * 校验位计算公式：Y_P = mod( ∑(Ai×Wi),11 )   
 * i为身份证号码从右往左数的 2...18 位; Y_P为脚丫校验码所在校验码数组位置  
 *   
 */  
  
var Wi = [ 7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2, 1 ];// 加权因子   
var ValideCode = [ 1, 0, 10, 9, 8, 7, 6, 5, 4, 3, 2 ];// 身份证验证位值.10代表X   
function IdCardValidate(idCard) {   
    idCard = trim(idCard.replace(/ /g, ""));   
    if (idCard.length == 15) {   
        return isValidityBrithBy15IdCard(idCard);   
    } else if (idCard.length == 18) {   
        var a_idCard = idCard.split("");// 得到身份证数组   
        if(isValidityBrithBy18IdCard(idCard)&&isTrueValidateCodeBy18IdCard(a_idCard)){   
            return true;   
        }else {   
            return false;   
        }   
    } else {   
        return false;   
    }   
}   
/**  
 * 判断身份证号码为18位时最后的验证位是否正确  
 * @param a_idCard 身份证号码数组  
 * @return  
 */  
function isTrueValidateCodeBy18IdCard(a_idCard) {   
    var sum = 0; // 声明加权求和变量   
    if (a_idCard[17].toLowerCase() == 'x') {   
        a_idCard[17] = 10;// 将最后位为x的验证码替换为10方便后续操作   
    }   
    for ( var i = 0; i < 17; i++) {   
        sum += Wi[i] * a_idCard[i];// 加权求和   
    }   
    valCodePosition = sum % 11;// 得到验证码所位置   
    if (a_idCard[17] == ValideCode[valCodePosition]) {   
        return true;   
    } else {   
        return false;   
    }   
}   
/**  
 * 通过身份证判断是男是女  
 * @param idCard 15/18位身份证号码   
 * @return 'female'-女、'male'-男  
 */  
function maleOrFemalByIdCard(idCard){   
    idCard = trim(idCard.replace(/ /g, ""));// 对身份证号码做处理。包括字符间有空格。   
    if(idCard.length==15){   
        if(idCard.substring(14,15)%2==0){   
            return 'female';   
        }else{   
            return 'male';   
        }   
    }else if(idCard.length ==18){   
        if(idCard.substring(14,17)%2==0){   
            return 'female';   
        }else{   
            return 'male';   
        }   
    }else{   
        return null;   
    }   
}   
 /**  
  * 验证18位数身份证号码中的生日是否是有效生日  
  * @param idCard 18位书身份证字符串  
  * @return  
  */  
function isValidityBrithBy18IdCard(idCard18){   
    var year =  idCard18.substring(6,10);   
    var month = idCard18.substring(10,12);   
    var day = idCard18.substring(12,14);   
    var temp_date = new Date(year,parseFloat(month)-1,parseFloat(day));   
    // 这里用getFullYear()获取年份，避免千年虫问题   
    if(temp_date.getFullYear()!=parseFloat(year)   
          ||temp_date.getMonth()!=parseFloat(month)-1   
          ||temp_date.getDate()!=parseFloat(day)){   
            return false;   
    }else{   
        return true;   
    }   
}   
  /**  
   * 验证15位数身份证号码中的生日是否是有效生日  
   * @param idCard15 15位书身份证字符串  
   * @return  
   */  
  function isValidityBrithBy15IdCard(idCard15){   
      var year =  idCard15.substring(6,8);   
      var month = idCard15.substring(8,10);   
      var day = idCard15.substring(10,12);   
      var temp_date = new Date(year,parseFloat(month)-1,parseFloat(day));   
      // 对于老身份证中的你年龄则不需考虑千年虫问题而使用getYear()方法   
      if(temp_date.getYear()!=parseFloat(year)   
              ||temp_date.getMonth()!=parseFloat(month)-1   
              ||temp_date.getDate()!=parseFloat(day)){   
                return false;   
        }else{   
            return true;   
        }   
  }   
//去掉字符串头尾空格   
function trim(str) {   
    return str.replace(/(^\s*)|(\s*$)/g, "");   
}  


/*
示例
required:true 必输字段
remote:"check.php" 使用ajax方法调用check.php验证输入值
email:true 必须输入正确格式的电子邮件
url:true 必须输入正确格式的网址
date:true 必须输入正确格式的日期
dateISO:true 必须输入正确格式的日期(ISO)，例如：2010-01-01，2010/01/01 只验证格式，不验证有效性
number:true 必须输入合法的数字(负数，小数)
digits:true 必须输入整数
creditcard: 必须输入合法的信用卡号
equalTo:"#field" 输入值必须和#field相同
accept: "gif|png|jpg" 输入拥有合法后缀名的字符串（上传文件的后缀），多个后缀之间用’|’隔开
maxlength:5 输入长度最多是5的字符串(汉字算一个字符)
minlength:10 输入长度最小是10的字符串(汉字算一个字符)
rangelength:[5,10] 输入长度必须介于 5 和 10 之间的字符串")(汉字算一个字符)
range:[5,10] 输入值必须介于 5 和 10 之间
max:5 输入值不能大于5
min:10 输入值不能小于10
说明：
1， remote是远程验证：比如注册验证用户名是否已被注册，返回值只能是true（验证成功）或false（验证失败）。
2， 某些属性值中的引号不能省略，否则出错。如accept、equalTo等。




*/
